/******************** (c) Marvell Semiconductor, Inc., 2002 *******************
 *
 * $Header: X:/APCVSDEPOT/Bootloader/AP21/ap21_tftp_boot/IOlayer.h,v 1.1.1.1 2002/12/30 20:44:05 cvu Exp $
 *
 * Purpose:
 *    Function prototypes for the IO layer of the 88E6208 RD board and 
 *	  the 88E6218 Development board.  
 *
 * Public Procedures:
 * 	  strToInt - Convert a string to a decimal number. 
 *	  GT_StrLen - Gets a STRING (char*) and count its charecters.
 *	  asciiToBinary - Convert a character to binary.
 *
 * Private Procedures:
 *    None
 *
 * Notes:
 *    None.
 *
 *****************************************************************************/

#ifndef _IO_LAYER_H_
#define _IO_LAYER_H_


//=============================================================================
//                    PUBLIC PROCEDURES (ANSI Prototypes)
//=============================================================================

/********************************************************************
* strToInt - Convert a string to a decimal number.
*          - This function gets a STRING (char*) it convert it to a decimal
*            format number.
*          - If the number of charecters given greater then 8 The number is
*            out of unsigned int format.
*
*
* INPUTS:   char* str - The String to be converted.
* OUPUT:    N/A
* RETURNS: - On success - the converted unsigned int, on failure it returns 
*            0xffffffff.
*********************************************************************/

unsigned int strToInt(char* str);

/********************************************************************
* GT_StrLen - Gets a STRING (char*) and count its charecters.
*
*
* INPUT:    char* s - A string which its charecters is to be counted.
* OUTPUT:   N/A
* RETURN:   unsigned int i - The number of charecters in the string.
*********************************************************************/

unsigned int GT_StrLen(char* s);

/********************************************************************
* asciiToBinary - Convert a character to binary.
*
*
* INPUTS:   char c - The charecter we wish to convert.
* OUTPUT:   N/A
* RETURNS: The binary value of the character.
*********************************************************************/

unsigned char asciiToBinary(char c);

#endif /* _IO_LAYER_H_ */