/*#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <rt_misc.h>
*/
#define _REG(x) (*(volatile unsigned long *)(x))
#define _REG16(x) (*(volatile unsigned short *)(x))
//===================================================================
// SDRAM controller registers
//
#define MDU_CSR      0x80006000
#define MDU_CFGR0    0x80006004
#define MDU_TIMR00   0x80006008    
#define MDU_TIMR01   0x8000600C
#define MDU_CFGR1    0x80006010
#define MDU_TIMR10   0x80006014
#define MDU_TIMR11   0x80006018
#define MDU_CFGR2    0x8000601C
#define MDU_TIMR20   0x80006020
#define MDU_TIMR21   0x80006024
#define MDU_CFGR3    0x80006028
#define MDU_TIMR30   0x8000602C
#define MDU_TIMR31   0x80006030
#define MDU_CFGR4    0x80006034
#define MDU_TIMR40   0x80006038
#define MDU_TIMR41   0x8000603C
#define MDU_CFGR5    0x80006040
#define MDU_TIMR50   0x80006044
#define MDU_TIMR51   0x80006048
#define MDU_CLOCK    0x8000200C
#define CLK_CTRL     0x80002030

int init_sdram(void)
{
#if 1
   int aa, bb;
   aa=0x50078;
   bb=(0x80000|(4 << 1));
   //bb=(0x98000000|(4 << 1));
//   _REG(MDU_CSR)    = 0x4190000; /*RefInt [31:18], brfr_cycle [17:16] */
#if CONDOR_BOARD
    _REG(MDU_CSR) = 0x04191001;  /* for 44 Mhz clock cpu speed */
    _REG(MDU_TIMR10) = 0x00000033; /* Burst of 8 bytes */
    _REG(MDU_TIMR11) = 0x0a3a2632;
    //_REG(MDU_CFGR1)  = 0x40Fc70b5; /* 0xd0000000 */
    #if defined(AP31P)
    _REG(MDU_CFGR1)  = 0x40FE70B7; /* 0xd0000000 */
    #else
    _REG(MDU_CFGR1)  = 0x40FF7095; /* 0xd0000000 */
    #endif
#else
#ifdef AP21N_BOARD
   _REG(MDU_CSR) = 0x157e0000;  /* for 88 Mhz clock cpu speed */
#else
   _REG(MDU_CSR) = 0x4190040;  /* for 88 Mhz clock cpu speed */
#endif
   _REG(MDU_TIMR00) = 0x0442A20C;   /* FLASH timing */
   _REG(MDU_TIMR01) = 0x00008080;
   _REG(MDU_CFGR0)  = 0xFFFF4285;   /* 0xffc00000 FLASH configuration pack_en = 1*/
#ifdef EAGLE_TESTBOARD
   _REG(MDU_TIMR20) = 0x00000022;
   _REG(MDU_TIMR21) = 0x03232222;
   _REG(MDU_CFGR2)  = 0x40FE50B5; /* 0xd0000000 */
#else
//   _REG(MDU_CFGR1)  = 0x40FF5095; /* 0xd0000000 */
#ifdef AP21N_BOARD
   _REG(MDU_TIMR10) = 0x00000032;
   _REG(MDU_TIMR11) = 0x0a3a2632;
  _REG(MDU_CFGR1)  = 0x40FE50b5; /* 0xd0000000 */
#else
   _REG(MDU_TIMR10) = 0x00000022;
   _REG(MDU_TIMR11) = 0x03232222;
  _REG(MDU_CFGR1)  = 0x40FF7095; /* 0xd0000000 */
#endif
#endif
   //disable devices 3 4 5

/*   _REG16(MDU_CLOCK)= 0xFFFF; */
   _REG(MDU_CSR)    = 0x157E0000;  /* for 88 Mhz clock cpu speed */
   _REG(MDU_TIMR10) = 0x00000032;
   _REG(MDU_TIMR11) = 0x0A3A2632;
   _REG(MDU_CFGR1)  = 0x40FE70B7; /* 0xd0000000 */
#endif //CONDOR_BOARD
   _REG(MDU_CFGR3) = 0xC0FF0008;
   _REG(MDU_CFGR4) = 0x80FF0008;
   _REG(MDU_CFGR5) = 0x40FF0008;
#if CONDOR_BOARD
    _REG(CLK_CTRL) = 0x7109;      //44Mhz
#if 1
    _REG(0x80002044) = 0x00e0001e;
#endif
    //_REG( 0x8000d004 ) = 0x7fff;  /* enables gpio 15 output mode */
    //_REG( 0x8000d00c ) = 0x7fff;   /* set gpio 15 low , reset peripherals */

    //os_TaskDelay(100);

    //_REG( 0x8000d00c ) = 0xffff;   /* set gpio 15 high, enable peripherals */
    //os_TaskDelay (100);
#endif
#endif
#if 0
    _REG(MDU_TIMR00) = 0x0442A20C;   /* FLASH timing */
    _REG(MDU_TIMR01) = 0x00008080;
    _REG(MDU_CFGR0)  = 0xFFFF4285;   /* 0xffc00000 FLASH configuration pack_en = 1*/

    _REG(MDU_CSR)    = 0x157E0000;   /* default setting */
    _REG(MDU_TIMR10) = 0x00000032;
    _REG(MDU_TIMR11) = 0x03232232;
    _REG(MDU_CFGR1)  = 0x40FE70B7;
    
    _REG(MDU_CSR)    = 0x20530000;
    _REG(MDU_TIMR10) = 0x00000032;
    _REG(MDU_TIMR11) = 0x0A3A3632;
    _REG(MDU_CFGR1)  = 0x40ff7095;//40FC70B5;
    // Disable devices 3 4 5
    _REG(MDU_CFGR3) = 0xC0FF0008;
    _REG(MDU_CFGR4) = 0x80FF0008;
    _REG(MDU_CFGR5) = 0x40FF0008;

    _REG(CLK_CTRL) = 0x7109;      //44Mhz
    _REG(0x80002044) = 0x00e0001e;
#endif
}
/*
  __value_in_regs struct __initial_stackheap __user_initial_stackheap(
  unsigned R0, unsigned SP, unsigned R2, unsigned SL)
  {
  struct __initial_stackheap config;
  
  config.heap_base = 0xc0008000;
  config.stack_base = 0xc000c000;
  
  return config;
  }
*/
