/******************** (c) Marvell Semiconductor, Inc., 2002 *******************
 *
 * $Header: X:/APCVSDEPOT/Bootloader/AP21/ap21_tftp_boot/gpio.c,v 1.1.1.1 2002/12/30 20:44:05 cvu Exp $
 *
 * Purpose:
 *    Low-level code to setup the GPIO.
 *
 * Public Procedures:
 *    gpio_out_en             Enable the GPIO pins for output.
 *    gpwr                    Write 16 bits of data to the GPIO pins
 *
 * Private Procedures:
 *    None.
 *
 * Notes:
 *    None.
 *
 *****************************************************************************/

//=============================================================================
//                               INCLUDE FILES
//=============================================================================
#include "88E6218.h"
#include "gpio.h"

//=============================================================================
//                         CODED PUBLIC PROCEDURES
//=============================================================================
/******************************************************************************
 *
 * Name: gpwr
 *
 * Description:
 *   Write a u16 to the previously enabled GPIO pins.
 *
 * Conditions For Use:
 *   GPIO Clock should be enabled before attempting to use. (In PAU).
 *
 * Arguments:
 *   Arg1( u16 ): 16 bits of data to appear at the pins.
 *
 * Return Value:
 *   None.
 *
 * Notes:
 *   None.
 *
 *****************************************************************************/
extern void 
gpwr(UINT16 data )
{
    GT_REG_WRITE(GPIO_OUT_DATA,data);  
}

