/**************************************************************************
ETHERBOOT -  BOOTP/TFTP Bootstrap Program

Author: Martin Renters
  Date: Dec/93

**************************************************************************/
#ifndef __INCgtTftp 
#define __INCgtTftp 


#include "MvCore.h"
#include "gtDma.h"
#ifndef	MAX_TFTP_RETRIES
    #define MAX_TFTP_RETRIES	20
#endif

#ifndef	MAX_ARP_RETRIES
    #define MAX_ARP_RETRIES		20
#endif

#define	TICKS_PER_SEC		18

/* Inter-packet retry in ticks */
#define TIMEOUT			(10*TICKS_PER_SEC)

/* These settings have sense only if compiled with -DCONGESTED */
/* total retransmission timeout in ticks */
//#define TFTP_TIMEOUT		(30*TICKS_PER_SEC)
/* packet retransmission timeout in ticks */
//#define TFTP_REXMT		(3*TICKS_PER_SEC)

/*#ifndef	NULL
    #define NULL	((void *)0)
#endif

#define TRUE		1
#define FALSE		0   */

#define ETHER_ADDR_SIZE		6	/* Size of Ethernet address */
#define ETHER_HDR_SIZE		14	/* Size of ethernet header */
//#define ETH_MIN_PACKET		64
#define ETH_MAX_PACKET		1518

#define ARP_CLIENT	0
#define ARP_SERVER	1
#define ARP_GATEWAY	2
#define ARP_ROOTSERVER	3
#define ARP_SWAPSERVER	4
#define MAX_ARP		ARP_SWAPSERVER+1

#define IP		0x0800
#define ARP		0x0806

#define TFTP_PORT	69
//#define SUNRPC_PORT	111

#define IP_UDP		17
/* Same after going through htonl */
#define IP_BROADCAST	0xFFFFFFFF

#define ARP_REQUEST	1
#define ARP_REPLY	2

/*#define TAG_LEN(p)		(*((p)+1))
#define RFC1533_COOKIE		99, 130, 83, 99
#define RFC1533_PAD		0
#define RFC1533_NETMASK		1
#define RFC1533_TIMEOFFSET	2
#define RFC1533_GATEWAY		3
#define RFC1533_TIMESERVER	4
#define RFC1533_IEN116NS	5
#define RFC1533_DNS		6
#define RFC1533_LOGSERVER	7
#define RFC1533_COOKIESERVER	8
#define RFC1533_LPRSERVER	9
#define RFC1533_IMPRESSSERVER	10
#define RFC1533_RESOURCESERVER	11
#define RFC1533_HOSTNAME	12
#define RFC1533_BOOTFILESIZE	13
#define RFC1533_MERITDUMPFILE	14
#define RFC1533_DOMAINNAME	15
#define RFC1533_SWAPSERVER	16
#define RFC1533_ROOTPATH	17
#define RFC1533_EXTENSIONPATH	18
#define RFC1533_IPFORWARDING	19
#define RFC1533_IPSOURCEROUTING	20
#define RFC1533_IPPOLICYFILTER	21
#define RFC1533_IPMAXREASSEMBLY	22
#define RFC1533_IPTTL		23
#define RFC1533_IPMTU		24
#define RFC1533_IPMTUPLATEAU	25
#define RFC1533_INTMTU		26
#define RFC1533_INTLOCALSUBNETS	27
#define RFC1533_INTBROADCAST	28
#define RFC1533_INTICMPDISCOVER	29
#define RFC1533_INTICMPRESPOND	30
#define RFC1533_INTROUTEDISCOVER 31
#define RFC1533_INTROUTESOLICIT	32
#define RFC1533_INTSTATICROUTES	33
#define RFC1533_LLTRAILERENCAP	34
#define RFC1533_LLARPCACHETMO	35
#define RFC1533_LLETHENCAP	36
#define RFC1533_TCPTTL		37
#define RFC1533_TCPKEEPALIVETMO	38
#define RFC1533_TCPKEEPALIVEGB	39
#define RFC1533_NISDOMAIN	40
#define RFC1533_NISSERVER	41
#define RFC1533_NTPSERVER	42
#define RFC1533_VENDOR		43
#define RFC1533_NBNS		44
#define RFC1533_NBDD		45
#define RFC1533_NBNT		46
#define RFC1533_NBSCOPE		47
#define RFC1533_XFS		48
#define RFC1533_XDM		49

#define RFC1533_VENDOR_MAJOR	0
#define RFC1533_VENDOR_MINOR	0

#define RFC1533_VENDOR_MAGIC	128
#define RFC1533_VENDOR_ADDPARM	129
#ifdef	IMAGE_FREEBSD
    #define RFC1533_VENDOR_HOWTO    132
#endif
#define RFC1533_VENDOR_MNUOPTS	160
#define RFC1533_VENDOR_SELECTION 176
#define RFC1533_VENDOR_MOTD	184
#define RFC1533_VENDOR_NUMOFMOTD 8
#define RFC1533_VENDOR_IMG	192
#define RFC1533_VENDOR_NUMOFIMG	16

#define RFC1533_END		255  */
//#define BOOTP_VENDOR_LEN	64
#ifndef	NO_DHCP_SUPPORT
    #define DHCP_OPT_LEN		312
#endif	/* NO_DHCP_SUPPORT */

#define	TFTP_DEFAULTSIZE_PACKET	512
#define	TFTP_MAX_PACKET		1432 /* 512 */

#define TFTP_RRQ	1
#define TFTP_WRQ	2
#define TFTP_DATA	3
#define TFTP_ACK	4
#define TFTP_ERROR	5
#define TFTP_OACK	6
/*
#define TFTP_CODE_EOF	1
#define TFTP_CODE_MORE	2
#define TFTP_CODE_ERROR	3
#define TFTP_CODE_BOOT	4
#define TFTP_CODE_CFG	5   */

#define AWAIT_ARP	    0
#define AWAIT_BOOTP	    1
#define AWAIT_TFTP	    2
#define AWAIT_RARP	    3
#define AWAIT_RPC	    4
#define AWAIT_QDRAIN	5	/* drain queue, process ARP requests */

typedef struct {
    unsigned long   s_addr;
} in_addr;

struct arptable_t {
    in_addr ipaddr;
    unsigned char node[6];
};

/*
 * A pity sipaddr and tipaddr are not longword aligned or we could use
 * in_addr. No, I don't want to use #pragma packed.
 */
struct arprequest {
    unsigned short hwtype;
    unsigned short protocol;
    char hwlen;
    char protolen;
    unsigned short opcode;
    char shwaddr[6];
    char sipaddr[4];
    char thwaddr[6];
    char tipaddr[4];
};

struct iphdr {
    char verhdrlen;
    char service;
    unsigned short len;
    unsigned short ident;
    unsigned short frags;
    char ttl;
    char protocol;
    unsigned short chksum;
    in_addr src;
    in_addr dest;
};

struct udphdr {
    unsigned short src;
    unsigned short dest;
    unsigned short len;
    unsigned short chksum;
};

struct bootp_t {
    struct iphdr ip;
    struct udphdr udp;
    char bp_op;
    char bp_htype;
    char bp_hlen;
    char bp_hops;
    unsigned long bp_xid;
    unsigned short bp_secs;
    unsigned short unused;
    in_addr bp_ciaddr;
    in_addr bp_yiaddr;
    in_addr bp_siaddr;
    in_addr bp_giaddr;
    char bp_hwaddr[16];
    char bp_sname[64];
    char bp_file[128];
#ifdef	NO_DHCP_SUPPORT
    char bp_vend[BOOTP_VENDOR_LEN];
#else
    char bp_vend[DHCP_OPT_LEN];
#endif	/* NO_DHCP_SUPPORT */
};

struct tftp_t { 
    struct iphdr ip;
    struct udphdr udp;
    unsigned short opcode;
    union {
        char rrq[TFTP_DEFAULTSIZE_PACKET];
        struct {
            unsigned short block;
            char download[TFTP_MAX_PACKET];
        } data;
        struct {
            unsigned short block;
        } ack;
        struct {
            unsigned short errcode;
            char errmsg[TFTP_DEFAULTSIZE_PACKET];
        } err;
        struct {
            char data[TFTP_DEFAULTSIZE_PACKET+2];
        } oack;
    } u;
} /* __attribute__((packed)) */;

typedef struct _eth_initialization
{
    char         serverIP[20];
    unsigned int portNumber;
    char         mac[20];
    unsigned int hashTableBaseAddr;
    unsigned int rxDescBaseAddr;
    unsigned int rxDataBuffBaseAddr;
    unsigned int txDescBaseAddr;
    unsigned int txDataBuffBaseAddr;
    char         fileName[100];
    char         loadAddr[10];
    DMA_ENGINE dmaEngine;
    unsigned int dmaCommand;
} eth_initialization;

#define TFTP_MIN_PACKET	(sizeof(struct iphdr) + sizeof(struct udphdr) + 4)


#define NT 1 /* Number of Transmit buffers */
#define NR 20 /* Number of Receive buffers */


/*
struct rpc_t {
    struct iphdr ip;
    struct udphdr udp;
    union {
        char data[300];     /* longest RPC call must fit!!!! */
    /*    struct {
            long id;
            long type;
            long rpcvers;
            long prog;
            long vers;
            long proc;
            long data[1];
        } call;
        struct {
            long id;
            long type;
            long rstatus;
            long verifier;
            long v2;
            long astatus;
            long data[1];
        } reply;
    } u;
};  */


//#define ESC		0x1B

//#define PROG_PORTMAP	100000

/***************************************************************************
External prototypes
***************************************************************************/
/* main.c */
extern int downloadkernel (unsigned char *, int, int, int);
extern int tftp (const char *name, int (*)(unsigned char *, int, int, int));
extern int udp_transmit (unsigned long destip, unsigned int srcsock,
                         unsigned int destsock, int len, const void *buf);

extern int await_reply (int type, int ival, void *ptr, int timeout);
extern unsigned short ipchksum (unsigned short *, int len);
extern void cleanup_net (void);
//extern void cleanup (void);

unsigned int tftpLoadExeFile(int argc,char **argv);
unsigned int tftpLoadFile(int argc,char **argv);
//extern void eth_reset(void);
void eth_transmit(int portNum, char *destAddr,  unsigned int packetType,         
                  unsigned int dataSize, char *dataPtr);          
extern void eth_init(int portNum);
extern bool eth_poll(int portNum);
extern void eth_disable(int portNum);

//extern int os_download (unsigned int, unsigned char *,unsigned int);
//extern void rfc951_sleep (int);
/***************************************************************************
External variables
***************************************************************************/
/* main.c */
/*
extern struct rom_info rom;
extern int hostnamelen;
extern unsigned long netmask;
extern int jmp_bootmenu[10];*/
extern struct arptable_t arptable[MAX_ARP];
/*#ifdef	IMAGE_MENU
extern char *motd[RFC1533_VENDOR_NUMOFMOTD];
extern int menutmo,menudefault;
extern unsigned char *defparams;
extern int defparams_max;
#endif
#if	defined(ETHERBOOT32) && !defined(INTERNAL_BOOTP_DATA)
    #define	BOOTP_DATA_ADDR	((struct bootpd_t *)0x93C00)
#else
extern struct bootpd_t bootp_data;
    #define	BOOTP_DATA_ADDR	(&bootp_data)
#endif   
extern unsigned char *end_of_rfc1533;
#ifdef	IMAGE_FREEBSD
extern int freebsd_howto;
#endif

/* config.c */
struct nic {
    void        (*reset)(struct nic *);
    int     (*poll)(struct nic *);
    void        (*transmit)(struct nic *, const unsigned char *d,
                            unsigned int t, unsigned int s, const char *p);
    void        (*disable)(struct nic *);
    char        aui;
    unsigned char   *node_addr;
    char        *packet;
    unsigned int    packetlen;
    void        *priv_data; /* driver can hang private data here */
};

extern struct nic nic; 

#endif /* __INCgtTftp */

