/*==========================================================================    */
/*                                                                              */
/*      cpuload.h                                                               */
/*                                                                              */
/*      Interface for the cpuload code.                                         */
/*                                                                              */
/*==========================================================================    */
/*####ECOSGPLCOPYRIGHTBEGIN####                                                 */
/* -------------------------------------------------------------------------    */
/* This file is part of eCos, the Embedded Configurable Operating System.       */
/* Copyright (C) 2002 Andrew Lunn                                               */
/*                                                                              */
/* eCos is free software; you can redistribute it and/or modify it under        */
/* the terms of the GNU General Public License as published by the Free         */
/* Software Foundation; either version 2 or (at your option) any later version. */
/*                                                                              */
/* eCos is distributed in the hope that it will be useful, but WITHOUT ANY      */
/* WARRANTY; without even the implied warranty of MERCHANTABILITY or            */
/* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License        */
/* for more details.                                                            */
/*                                                                              */
/* You should have received a copy of the GNU General Public License along      */
/* with eCos; if not, write to the Free Software Foundation, Inc.,              */
/* 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.                       */
/*                                                                              */
/* As a special exception, if other files instantiate templates or use macros   */
/* or inline functions from this file, or you compile this file and link it     */
/* with other works to produce a work based on this file, this file does not    */
/* by itself cause the resulting work to be covered by the GNU General Public   */
/* License. However the source code for this file must still be made available  */
/* in accordance with section (3) of the GNU General Public License.            */
/*                                                                              */
/* This exception does not invalidate any other reasons why a work based on     */
/* this file might be covered by the GNU General Public License.                */
/*                                                                              */
/* Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.    */
/* at http://sources.redhat.com/ecos/ecos-license/                              */
/* -----------------------------------------------------------------------------*/
/*####ECOSGPLCOPYRIGHTEND####                                                   */
/*==============================================================================*/
/*#####DESCRIPTIONBEGIN####                                                     */
/*                                                                              */
/* Author(s):    Andrew Lunn                                                    */
/* Contributors: Andrew Lunn                                                    */
/* Date:         2002-08-12                                                     */
/* Purpose:                                                                     */
/* Description:                                                                 */
/*      API for the cpuload measurement code                                    */
/*                                                                              */
/* This code is part of eCos (tm).                                              */
/*                                                                              */
/*####DESCRIPTIONEND####                                                        */
/*                                                                              */
/*==============================================================================*/
#ifndef _TXSTATS_H_
#define _TXSTATS_H_

#include "wltypes.h"


/*Defines teh maximumstations to log the tx stats from. */

/*#define MAX_STN 3 */
typedef struct sTxStats 
{
  UINT8 RetryCnt;
  UINT8 Rate;
  UINT8 Success;
  UINT8 Drops;
  UINT16 PktLen;
  UINT16 Status;
  /*Including RxStats value here as well. */
  UINT8 Rcv_Sq1;
  UINT8 Rcv_Sq2; 
  UINT8 Rcv_RSSI; 
  UINT8 Rx_Rate;
} 
PACK_END sTxStats;

void UpdateTxStats(txInfo_t *txInfo_p);


#endif
