/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
*
* $Header: \\\\matar\\w81_doc/W81/802.11_MAC-DRIVER_SW/AP/Src/dhcptask.c
* 
* Purpose: 
*    This file contains the implementations of the function prototypes given 
*    in the associated header file for the dhcp Task. 
* 
* Public Procedures: 
*
* 
* Private Procedures: 
*
* 
* Notes: 
*    None. 
* 
*****************************************************************************/

/*============================================================================= */
/*                               INCLUDE FILES */
/*============================================================================= */
#include "wltypes.h"
#include "IEEE_types.h"
#include "sysinfo.h"
#include "osif.h"
#include "oem.h"

#include <cyg/kernel/kapi.h>
#include <pkgconf/system.h>
#include <pkgconf/net.h>


extern int dhcp_bind(void);
extern unsigned char stationJoined;
extern UINT8 mib_dhcpenable;
extern UINT8 mib_dhcpstatechange;
extern cyg_sem_t dhcp_needs_attention;
extern cyg_thread_entry_t dhcp_mgt_entry;

/*============================================================================= */
/*                                DEFINITIONS */
/*============================================================================= */
#ifdef USE_NEW_OSIF
static TASK_HANDLE dhcpTH;
//wuming temp
//static UINT8  Stack[sysinfo_DHCP_TASK_STACK_SIZE]__attribute__ ((section (".itcmbuf")));
static UINT8  Stack[sysinfo_DHCP_TASK_STACK_SIZE];

#endif

static void DHCPTask( OS_DATA Data );

/*============================================================================= */
/*                         CODED PUBLIC PROCEDURES */
/*============================================================================= */

/******************************************************************************
 * 
 * Name: dhcpTask_Init 
 * 
 * Description: 
 *   This routine is called to initialize the the Web Server Task 
 *   and related components. 
 * 
 * Conditions For Use: 
 *   None. 
 * 
 * Arguments: 
 *   None. 
 * 
 * Return Value: 
 *   Status indicating success or failure 
 * 
 * Notes: 
 *   None. 
 * 
 * PDL: 
 * 
 *   
 * END PDL 
 * 
 *****************************************************************************/

#ifdef TASKDHCP
extern WL_STATUS dhcpTask_Init( void )
{
    WL_STATUS status;
    cyg_semaphore_init( &dhcp_needs_attention, 0 );
#ifdef USE_NEW_OSIF
    if ((status = os_TaskCreate(&dhcpTH,
                               dhcp_mgt_entry,
                               (OS_DATA)1,
                               sysinfo_DHCP_TASK_NAME,
                               (void *)Stack,
                               sysinfo_DHCP_TASK_STACK_SIZE,
                               sysinfo_DHCP_TASK_PRI)) == OS_SUCCESS)
    {
#else
    if ((status = os_TaskCreate(sysinfo_DHCP_TASK,
                               dhcp_mgt_entry,
                               (os_Addrword_t)1,
                               sysinfo_DHCP_TASK_NAME,
                               sysinfo_DHCP_TASK_STACK_SIZE,
                               sysinfo_DHCP_TASK_PRI)) == OS_SUCCESS)
    {
#endif
        return (OS_SUCCESS);
    }
    return (OS_FAIL);
}


extern void dhcp_Start( void )
{
#ifdef USE_NEW_OSIF
    os_TaskResume(dhcpTH);
#else
    os_TaskResume(sysinfo_DHCP_TASK);
#endif
}
#endif

/*============================================================================= */
/*                         CODED PRIVATE PROCEDURES */
/*============================================================================= */

/******************************************************************************
 * 
 * Name: WebTask 
 * 
 * Description: 
 * 
 * Conditions For Use: 
 *   The task and related components have been initialized by calling 
 *   web_Init() and then the task has been started by calling 
 *   web_Start(). 
 * 
 * Arguments: 
 *   Arg1 (i  ): Data - Data passed to the task; not actually used - just 
 *                      included to conform to the structure the OS 
 *                      expects when creating a task 
 * 
 * Return Value: 
 *   None. 
 * 
 * Notes: 
 *   None. 
 * 
 * PDL: 
 * END PDL 
 * 
 *****************************************************************************/
#ifdef  TASKDHCP
static void DHCPTask( OS_DATA Data )
{
    dhcp_bind(); /*Not use right now, already replace by dhcp_mgt_entry */
}
#endif

