/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
*
* $Header: E:\\APCVSDEPOT/wlan/prod/ap/ap31/bridge/src/web.c,v 1.5 2004/01/24 00:53:24 jshen Exp $ 
* 
* Purpose: 
*    This file contains the implementations of the function prototypes given 
*    in the associated header file for the Web server Task. 
* 
* Public Procedures: 
*
* 
* Private Procedures: 
*
* 
* Notes: 
*    None. 
* 
*****************************************************************************/

/*============================================================================= */
/*                               INCLUDE FILES */
/*============================================================================= */
#include "wltypes.h"
#include "IEEE_types.h"
#include "sysinfo.h"
#include "osif.h"
#include "oem.h"


/*============================================================================= */
/*                                DEFINITIONS */
/*============================================================================= */



/*============================================================================= */
/*                             GLOBAL VARIABLES */
/*============================================================================= */
extern int webmain(void);


/*============================================================================= */
/*                   PRIVATE PROCEDURES (ANSI Prototypes) */
/*============================================================================= */
static void WebTask( OS_DATA Data );

/*============================================================================= */
/*                         CODED PUBLIC PROCEDURES */
/*============================================================================= */

/******************************************************************************
 * 
 * Name: Web_Init 
 * 
 * Description: 
 *   This routine is called to initialize the the Web Server Task 
 *   and related components. 
 * 
 * Conditions For Use: 
 *   None. 
 * 
 * Arguments: 
 *   None. 
 * 
 * Return Value: 
 *   Status indicating success or failure 
 * 
 * Notes: 
 *   None. 
 * 
 * PDL: 
 * 
 *   
 * END PDL 
 * 
 *****************************************************************************/
static cyg_thread Task;
static cyg_handle_t TaskHdl;
#define  sysinfo_WEB_TASK_NAME          "Web"
#define  sysinfo_WEB_TASK               8
#define  sysinfo_WEB_TASK_STACK_SIZE    (8*1024)
#define  sysinfo_WEB_TASK_PRI           20

static UINT8 WebStack[sysinfo_WEB_TASK_STACK_SIZE] __attribute__ ((aligned (4)));

extern WL_STATUS web_Init( void )
{
    cyg_thread_create(sysinfo_WEB_TASK_PRI,
                      WebTask,
                      0,
                      sysinfo_WEB_TASK_NAME,
                      (void *)(WebStack),
                      sysinfo_WEB_TASK_STACK_SIZE,
                      &TaskHdl,
                      &Task);
    return (OS_SUCCESS);
}

/******************************************************************************
 * 
 * Name: web_Start 
 * 
 * Description: 
 *   This routine is called to start the Web Server Task running. 
 * 
 * Conditions For Use: 
 *   The task and its associated queues has been initialized by calling 
 *   web_Init(). 
 * 
 * Arguments: 
 *   None. 
 * 
 * Return Value: 
 *   None. 
 * 
 * Notes: 
 *   None. 
 * 
 * PDL: 
 *    Start the Web Server Tasl by calling os_TaskResume() 
 * END PDL 
 * 
 *****************************************************************************/
extern void web_Start( void )
{

    /*   os_TaskResume(sysinfo_WEB_TASK); */
    cyg_thread_resume(TaskHdl);

}

/*============================================================================= */
/*                         CODED PRIVATE PROCEDURES */
/*============================================================================= */

/******************************************************************************
 * 
 * Name: WebTask 
 * 
 * Description: 
 * 
 * Conditions For Use: 
 *   The task and related components have been initialized by calling 
 *   web_Init() and then the task has been started by calling 
 *   web_Start(). 
 * 
 * Arguments: 
 *   Arg1 (i  ): Data - Data passed to the task; not actually used - just 
 *                      included to conform to the structure the OS 
 *                      expects when creating a task 
 * 
 * Return Value: 
 *   None. 
 * 
 * Notes: 
 *   None. 
 * 
 * PDL: 
 * END PDL 
 * 
 *****************************************************************************/
static void WebTask( OS_DATA Data )
{
    /*#ifndef TASKDHCP */
    /*     dhcp_bind(); */
    /*#endif */
#ifndef AP31E
#ifdef  ENABLE_WEB_SERVER
    webmain();
#endif
#endif
}
