/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
*
* $Header: E:\\APCVSDEPOT/wlan/prod/ap/ap31/bridge/src/wep.c,v 1.21 2004/04/13 20:59:38 jshen Exp $
*
* Purpose:
*    This file contains the implementations of the Fragment and WEP. 
*
* Public Procedures:
*		
*		
*
* Private Procedures:
*
* Notes:
*    None.
*
*****************************************************************************/ 
/*============================================================================= */
/*                               INCLUDE FILES */
/*============================================================================= */
#include "wltypes.h"
#include "buildModes.h"
#include "osif.h"
#include "sysinfo.h"
#include "IEEE_types.h"
#include "wl_mib.h"
#include "wl_hal.h"
#include "tkip.h"
#include "rx80211.h"
#include "ap_mib.h"
#include "memmap.h"
#include "wl_macros.h"
#include "mcu.h"
#include "wep.h"
#include "tkip.h"
#include "isr.h"
#ifdef OS_VxW
#include "cachelib.h"
#endif


/*============================================================================= */
/*                                DEFINITIONS */
/*============================================================================= */

#define MAX_FRAGOUT_NUM       MAX_BUF_UNIT*TX_BUF_NUM
#define WL_80211_HEADER_SIZE 32
#define FRAGMENT_HD_SIZE      32
#define FCS_SIZE              4
#define IEEE80211_SIFS        10    /*10us */
#define CTS_BASIC_DUR         112   /*14*8 */
#define WEPOVERHEAD           8
#define IV_KEYID_FIELD_SIZE   4
#define LLC_SNAP_SIZE         6

#if 0
typedef enum _WL_KEY_TYPE
{
    WEB_40_BIT,
    WEB_104_BIT
}
WL_KEY_TYPE;
#endif




/*============================================================================= */
/*                              TYPE DEFINITIONS */
/*============================================================================= */




/*============================================================================= */
/*                         IMPORTED PUBLIC VARIABLES */
/*============================================================================= */

extern UINT32 dma0_busy;
extern volatile UINT32 txwep_busy;
extern MIB_WEP_DEFAULT_KEYS mib_WepDefaultKeys[mib_MAX_DEFAULT_KEYS];
/*============================================================================= */
/*                          MODULE LEVEL VARIABLES */
/*============================================================================= */

UINT32 IV = 0x00;
UINT32 KeyId = 0;
#ifdef ENABLE_104BIT_KEY
UINT32 WepTypeAll = 2;
#else
UINT32 WepTypeAll = 1;
#endif

UINT8 WepType[4];

/*CTS & ACK durations in microsecond at 1,2,5.5,11,22,54 Mbit/s */
extern UINT8 Cts_Ack_Dur[8];
#ifdef WEP_ITCM
#if WEP_ITCM > 1
extern void wep_encrypt(unsigned char *buf, int len) __attribute__ ((section (".itcmbuf")));
#else
extern void wep_encrypt(unsigned char *buf, int len) __attribute__ ((section (".data")));
#endif
#else
extern void wep_encrypt(unsigned char *buf, int len);
#endif

extern BOOLEAN msi_wl_SetRxWEPKey(UINT32 keyId, UINT32 keyType, UINT8 * key);
extern BOOLEAN msi_wl_SetTxWEPKey(UINT32 keyType, UINT8 * key);


/*============================================================================= */
/*                   IMPORTED PUBLIC PROCEDURES (ANSI Prototypes) */
/*============================================================================= */

/*============================================================================= */
/*                   PRIVATE PROCEDURES (ANSI Prototypes) */
/*============================================================================= */

void FragDoDMAnEncrypt(UINT32, UINT32, UINT32);

/*============================================================================= */
/*                         CODED PUBLIC PROCEDURES */
/*============================================================================= */
/******************************************************************************
 *
 * Name: InitWep
 *
 * Description:
 *   
 *
 * Conditions For Use:
 *   None.
 *
 * Arguments:
 *   None.
 *
 * Return Value:
 *   buffer pointer
 *
 * Notes:
 *   None.
 *
 * PDL:
 *    os_TaskCreate() to create the task
 * END PDL
 *
 ****************************************************************************/
extern void InitWep(int keyindex)
{
    int i;
    UINT8 keyTmp[16] __attribute__ ((aligned(4))) ;
    /* */
    /* Setup WEP registers */
    /* */
    for (i = 0; i < mib_MAX_DEFAULT_KEYS; i++)
    {
        memcpy(keyTmp, mib_WepDefaultKeys_p[i].WepDefaultKeyValue, 13);
        /*WL_RxSetWepDefaultKey(keyTmp, i, 1); */
        /*WL_RxSetWepDefaultKey(UINT8* Key_p, UINT32 KeyId, UINT32 Wep2) */
        
        if (WepTypeAll == 2)
            msi_wl_SetRxWEPKey(i, WEB_104_BIT, keyTmp);
        else
            msi_wl_SetRxWEPKey(i, WEB_40_BIT, keyTmp);

        /* Tx key default to key 0 */
        if (i == keyindex)
        {
            if (WepTypeAll == 2)
                msi_wl_SetTxWEPKey(WEB_104_BIT, keyTmp);
            else
                msi_wl_SetTxWEPKey(WEB_40_BIT, keyTmp);
        }
    }
}





/******************************************************************************
 *
 * Name: DoEncrypt
 *
 * Description:
 *   This routine is normally called by DoFragment() to move fragment to tx 
 *   buffer as well as encrypt the pdu
 *
 * Conditions For Use:
 *   None.
 *
 * Arguments:
 *   DmaDesBlck_p   pointer to the chain of DMA descriptors
 *
 * Return Value:
 *
 *
 * Notes:
 *   None.
 *
 * PDL:
 *    
 * END PDL
 *
 ****************************************************************************/
void DoEncrypt(UINT32 des, UINT32 src, UINT32 len)
{
    UINT16 i;
    UINT32 InitVector;
    UINT32 loop_cnt = 0;
    IV++;
    InitVector=IV&0x00ffffff;
    KeyId = mib_defaultkeyindex;

    while ( WL_REGS32(RX_WEP_CMD)&(WEP_CMD_TXWEP_BUSY| WEP_CMD_TXWEP_TRIG) )
    {
        for ( i=0;i<10;i++ );
        if(loop_cnt++ > 10000)
            return;
    }
    WL_WRITE_WORD(des + WL_80211_HEADER_SIZE, InitVector | (KeyId << 30));

    /* */
    /* set IV */
    /* */
    WL_TxSetWepIV(InitVector);
    /* */
    /* Program read/write addresses and length */
    /* */
#ifdef OS_VxW
    cacheFlush(DATA_CACHE, (void*)(src + WL_80211_HEADER_SIZE), (size_t)(len));
    cacheInvalidate(DATA_CACHE, (void*)(des + WL_80211_HEADER_SIZE + 4), (size_t)(len));
#endif 
    WL_WRITE_WORD(RX_SW_ENC_RDADDR, src + WL_80211_HEADER_SIZE);
    WL_WRITE_WORD(RX_SW_ENC_WRADDR, des + WL_80211_HEADER_SIZE + 4);
    WL_WRITE_WORD(RX_SW_ENC_LEN, len);



    /* */
    /* start wep */
    /* */
    if (WepTypeAll == 2)
    {
        WL_WRITE_WORD(RX_WEP_CMD, WEP_CMD_WEP_START | WEP_CMD_WEP128); /*128 bit */
    } else
        {
        WL_WRITE_WORD(RX_WEP_CMD, WEP_CMD_WEP_START); /*40bit */
        }

    /*clear TXWEP_DONE interrupt */
    /*WL_REGS32_CLRBITS(MIR_INTR_STATUS, TXWEP_DONE);*/
}


extern unsigned long crc32_table[256];

#if 0
#ifdef WEP_ITCM
#if WEP_ITCM > 1
static unsigned long crc32_table[256]__attribute__ ((section (".itcmbuf"))) = {
#else
static unsigned long crc32_table[256]__attribute__ ((section (".data"))) = {
#endif
#else
static unsigned long crc32_table[256] = {
#endif
            0x00000000L, 0x77073096L, 0xee0e612cL, 0x990951baL, 0x076dc419L,
            0x706af48fL, 0xe963a535L, 0x9e6495a3L, 0x0edb8832L, 0x79dcb8a4L,
            0xe0d5e91eL, 0x97d2d988L, 0x09b64c2bL, 0x7eb17cbdL, 0xe7b82d07L,
            0x90bf1d91L, 0x1db71064L, 0x6ab020f2L, 0xf3b97148L, 0x84be41deL,
            0x1adad47dL, 0x6ddde4ebL, 0xf4d4b551L, 0x83d385c7L, 0x136c9856L,
            0x646ba8c0L, 0xfd62f97aL, 0x8a65c9ecL, 0x14015c4fL, 0x63066cd9L,
            0xfa0f3d63L, 0x8d080df5L, 0x3b6e20c8L, 0x4c69105eL, 0xd56041e4L,
            0xa2677172L, 0x3c03e4d1L, 0x4b04d447L, 0xd20d85fdL, 0xa50ab56bL,
            0x35b5a8faL, 0x42b2986cL, 0xdbbbc9d6L, 0xacbcf940L, 0x32d86ce3L,
            0x45df5c75L, 0xdcd60dcfL, 0xabd13d59L, 0x26d930acL, 0x51de003aL,
            0xc8d75180L, 0xbfd06116L, 0x21b4f4b5L, 0x56b3c423L, 0xcfba9599L,
            0xb8bda50fL, 0x2802b89eL, 0x5f058808L, 0xc60cd9b2L, 0xb10be924L,
            0x2f6f7c87L, 0x58684c11L, 0xc1611dabL, 0xb6662d3dL, 0x76dc4190L,
            0x01db7106L, 0x98d220bcL, 0xefd5102aL, 0x71b18589L, 0x06b6b51fL,
            0x9fbfe4a5L, 0xe8b8d433L, 0x7807c9a2L, 0x0f00f934L, 0x9609a88eL,
            0xe10e9818L, 0x7f6a0dbbL, 0x086d3d2dL, 0x91646c97L, 0xe6635c01L,
            0x6b6b51f4L, 0x1c6c6162L, 0x856530d8L, 0xf262004eL, 0x6c0695edL,
            0x1b01a57bL, 0x8208f4c1L, 0xf50fc457L, 0x65b0d9c6L, 0x12b7e950L,
            0x8bbeb8eaL, 0xfcb9887cL, 0x62dd1ddfL, 0x15da2d49L, 0x8cd37cf3L,
            0xfbd44c65L, 0x4db26158L, 0x3ab551ceL, 0xa3bc0074L, 0xd4bb30e2L,
            0x4adfa541L, 0x3dd895d7L, 0xa4d1c46dL, 0xd3d6f4fbL, 0x4369e96aL,
            0x346ed9fcL, 0xad678846L, 0xda60b8d0L, 0x44042d73L, 0x33031de5L,
            0xaa0a4c5fL, 0xdd0d7cc9L, 0x5005713cL, 0x270241aaL, 0xbe0b1010L,
            0xc90c2086L, 0x5768b525L, 0x206f85b3L, 0xb966d409L, 0xce61e49fL,
            0x5edef90eL, 0x29d9c998L, 0xb0d09822L, 0xc7d7a8b4L, 0x59b33d17L,
            0x2eb40d81L, 0xb7bd5c3bL, 0xc0ba6cadL, 0xedb88320L, 0x9abfb3b6L,
            0x03b6e20cL, 0x74b1d29aL, 0xead54739L, 0x9dd277afL, 0x04db2615L,
            0x73dc1683L, 0xe3630b12L, 0x94643b84L, 0x0d6d6a3eL, 0x7a6a5aa8L,
            0xe40ecf0bL, 0x9309ff9dL, 0x0a00ae27L, 0x7d079eb1L, 0xf00f9344L,
            0x8708a3d2L, 0x1e01f268L, 0x6906c2feL, 0xf762575dL, 0x806567cbL,
            0x196c3671L, 0x6e6b06e7L, 0xfed41b76L, 0x89d32be0L, 0x10da7a5aL,
            0x67dd4accL, 0xf9b9df6fL, 0x8ebeeff9L, 0x17b7be43L, 0x60b08ed5L,
            0xd6d6a3e8L, 0xa1d1937eL, 0x38d8c2c4L, 0x4fdff252L, 0xd1bb67f1L,
            0xa6bc5767L, 0x3fb506ddL, 0x48b2364bL, 0xd80d2bdaL, 0xaf0a1b4cL,
            0x36034af6L, 0x41047a60L, 0xdf60efc3L, 0xa867df55L, 0x316e8eefL,
            0x4669be79L, 0xcb61b38cL, 0xbc66831aL, 0x256fd2a0L, 0x5268e236L,
            0xcc0c7795L, 0xbb0b4703L, 0x220216b9L, 0x5505262fL, 0xc5ba3bbeL,
            0xb2bd0b28L, 0x2bb45a92L, 0x5cb36a04L, 0xc2d7ffa7L, 0xb5d0cf31L,
            0x2cd99e8bL, 0x5bdeae1dL, 0x9b64c2b0L, 0xec63f226L, 0x756aa39cL,
            0x026d930aL, 0x9c0906a9L, 0xeb0e363fL, 0x72076785L, 0x05005713L,
            0x95bf4a82L, 0xe2b87a14L, 0x7bb12baeL, 0x0cb61b38L, 0x92d28e9bL,
            0xe5d5be0dL, 0x7cdcefb7L, 0x0bdbdf21L, 0x86d3d2d4L, 0xf1d4e242L,
            0x68ddb3f8L, 0x1fda836eL, 0x81be16cdL, 0xf6b9265bL, 0x6fb077e1L,
            0x18b74777L, 0x88085ae6L, 0xff0f6a70L, 0x66063bcaL, 0x11010b5cL,
            0x8f659effL, 0xf862ae69L, 0x616bffd3L, 0x166ccf45L, 0xa00ae278L,
            0xd70dd2eeL, 0x4e048354L, 0x3903b3c2L, 0xa7672661L, 0xd06016f7L,
            0x4969474dL, 0x3e6e77dbL, 0xaed16a4aL, 0xd9d65adcL, 0x40df0b66L,
            0x37d83bf0L, 0xa9bcae53L, 0xdebb9ec5L, 0x47b2cf7fL, 0x30b5ffe9L,
            0xbdbdf21cL, 0xcabac28aL, 0x53b39330L, 0x24b4a3a6L, 0xbad03605L,
            0xcdd70693L, 0x54de5729L, 0x23d967bfL, 0xb3667a2eL, 0xc4614ab8L,
            0x5d681b02L, 0x2a6f2b94L, 0xb40bbe37L, 0xc30c8ea1L, 0x5a05df1bL,
            0x2d02ef8dL
        };
#endif

#define MAXKEYLEN 13
#ifdef WEP_ITCM
#if WEP_ITCM > 1
unsigned char S[256]__attribute__ ((section (".itcmbuf"))) = {0};
#else
unsigned char S[256]__attribute__ ((section (".data"))) = {0};
#endif
#else
unsigned char S[256];
#endif
unsigned char key[MAXKEYLEN + 3];
unsigned char klen;
static unsigned char IVReset = 0;
#define S_SWAP(a,b) do { unsigned char  t = S[a]; S[a] = S[b]; S[b] = t; } while(0)

#ifdef USEITCMBUF
unsigned char tempbuf[2*1024]__attribute__ ((section (".dtcmbuf"))) = {0};
#endif

#ifdef SELF_CTS
#define S_ACK_SWAP(a,b) do { unsigned char  t = S_ACK[a]; S_ACK[a] = S_ACK[b]; S_ACK[b] = t; } while(0)
unsigned char S_ACK[256]__attribute__ ((section (".itcmbuf"))) = {0};
void crc32forCts(unsigned char *buf, int len)
{

    unsigned long i, j, k, crc;
    unsigned char  *pos;
    unsigned char tmp[10] = {0xd4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

    /* Prepend 24-bit IV to RC4 key and TX frame */
    for (i = 0; i< 10; i++)
    {
        tmp[i] = buf[i];
    }
    pos = tmp;

    /* Compute CRC32 over unencrypted data and apply RC4 to data */
    crc = ~0;
    i = j = 0;
    for (k = 0; k < len; k++)
    {
        crc = crc32_table[(crc ^ *pos) & 0xff] ^ (crc >> 8);
        i = (i + 1) & 0xff;
        j = (j + S_ACK[i]) & 0xff;
        S_ACK_SWAP(i, j);
        *pos++ ^= S_ACK[(S_ACK[i] + S_ACK[j]) & 0xff];
    }
    crc = ~crc;

    /* Append little-endian CRC32 and encrypt it to produce ICV */
    buf[10] = crc;
    buf[11] = crc >> 8;
    buf[12] = crc >> 16;
    buf[13] = crc >> 24;

}
#endif

/* Perform WEP encryption on given buffer. Buffer needs to has 4 bytes of
 * extra space (IV) in the beginning, then len bytes of data, and finally
 * 4 bytes of extra space (ICV). Both IV and ICV will be transmitted, so the
 * payload length increases with 8 bytes.
 *
 * WEP frame payload: IV + TX key idx, RC4(data), ICV = RC4(CRC32(data))
 */

void wep_encrypt(unsigned char *buf, int len)
{

    unsigned long i, j, k, crc;
    unsigned char kpos, *pos;


    IV++;


    /* Prepend 24-bit IV to RC4 key and TX frame */
    pos = buf;
    *pos++ = key[0] = (IV >> 16) & 0xff;
    *pos++ = key[1] = (IV >> 8) & 0xff;
    *pos++ = key[2] = IV & 0xff;
    *pos++ = mib_defaultkeyindex << 6;


    if (WepTypeAll == 1) /*40 bit */
        klen = 3 + 5;
    else if (WepTypeAll == 2)
        klen = 3 + 13; /*128 bit */


    for (i = 0;i < klen - 3;i++)
        key[3 + i] = mib_WepDefaultKeys_p[mib_defaultkeyindex].WepDefaultKeyValue[i];
    IVReset = 1;


    /* Setup RC4 state */
    {


        for (i = 0; i < 256; i++)
            S[i] = i;
        j = 0;
        kpos = 0;
        for (i = 0; i < 256; i++)
        {
            j = (j + S[i] + key[kpos]) & 0xff;
            kpos++;
            if (kpos >= klen)
                kpos = 0;
            S_SWAP(i, j);
        }

    }


    /* Compute CRC32 over unencrypted data and apply RC4 to data */
    crc = ~0;
    i = j = 0;
    for (k = 0; k < len; k++)
    {
        crc = crc32_table[(crc ^ *pos) & 0xff] ^ (crc >> 8);
        i = (i + 1) & 0xff;
        j = (j + S[i]) & 0xff;
        S_SWAP(i, j);
        *pos++ ^= S[(S[i] + S[j]) & 0xff];
    }
    crc = ~crc;

    /* Append little-endian CRC32 and encrypt it to produce ICV */
    pos[0] = crc;
    pos[1] = crc >> 8;
    pos[2] = crc >> 16;
    pos[3] = crc >> 24;
    for (k = 0; k < 4; k++)
    {
        i = (i + 1) & 0xff;
        j = (j + S[i]) & 0xff;
        S_SWAP(i, j);
        *pos++ ^= S[(S[i] + S[j]) & 0xff];
    }



}
#ifdef USEITCMBUF
void wep_encrypt2(UINT32 dest, UINT32 src, UINT32 len)
{
    unsigned long i, j, k, crc;
    unsigned char kpos, *pos;



    IV++;


    memcpy(tempbuf + 4, src + 32, len + 4);

    pos = tempbuf;


    /* Prepend 24-bit IV to RC4 key and TX frame */
    /* pos = buf; */
    *pos++ = key[0] = (IV >> 16) & 0xff;
    *pos++ = key[1] = (IV >> 8) & 0xff;
    *pos++ = key[2] = IV & 0xff;
    *pos++ = mib_defaultkeyindex << 6;

    if (!IVReset)
    {
        if (WepTypeAll == 0) /*40 bit */
            klen = 3 + 5;
        else
            klen = 3 + 13; /*128 bit */
        for (i = 0;i < klen - 3;i++)
            key[3 + i] = mib_WepDefaultKeys_p[mib_defaultkeyindex].WepDefaultKeyValue[i];
        IVReset = 1;
    }
    /*	memcpy(key + 3, mib_WepDefaultKeys_p[mib_defaultkeyindex].WepDefaultKeyValue,klen-3); */

    /* Setup RC4 state */
    {


        for (i = 0; i < 256; i++)
            S[i] = i;
        j = 0;
        kpos = 0;
        for (i = 0; i < 256; i++)
        {
            j = (j + S[i] + key[kpos]) & 0xff;
            kpos++;
            if (kpos >= klen)
                kpos = 0;
            S_SWAP(i, j);
        }

    }


    /* Compute CRC32 over unencrypted data and apply RC4 to data */
    crc = ~0;
    i = j = 0;
    for (k = 0; k < len; k++)
    {
        crc = crc32_table[(crc ^ *pos) & 0xff] ^ (crc >> 8);
        i = (i + 1) & 0xff;
        j = (j + S[i]) & 0xff;
        S_SWAP(i, j);
        *pos++ ^= S[(S[i] + S[j]) & 0xff];
    }
    crc = ~crc;

    /* Append little-endian CRC32 and encrypt it to produce ICV */
    pos[0] = crc;
    pos[1] = crc >> 8;
    pos[2] = crc >> 16;
    pos[3] = crc >> 24;
    for (k = 0; k < 4; k++)
    {
        i = (i + 1) & 0xff;
        j = (j + S[i]) & 0xff;
        S_SWAP(i, j);
        *pos++ ^= S[(S[i] + S[j]) & 0xff];
    }

    memcpy(dest + 32, tempbuf, len + 8);

}
#endif

