/****************************************************************************
 *   $Header: E:\\APCVSDEPOT/wlan/prod/ap/ap31/build/aproot.c,v 1.10 2004/06/15 20:12:15 jshen Exp $
 *
 *        root.c
 *
 *        802.11 MAC  modules
 *        Copy Righti(2001) Marvell Semiconductors, Inc.
 *
 *                                                                          
 * Author(s):    Senthil Arumugham 
 * Date:          2001-05-18
 * Description:   
 ***************************************************************************/

#include "sysinfo.h"
#include "osif.h"
#include "buildModes.h"
#include "IEEE_types.h"
#include "ds.h"
#include "ap_api.h"
#include "usrcfg.h"
#include "dsport.h"


usr_Cfg_t usrCfg = {0xffffff70, 64, 13, 1, 0, 0, 0};

void usr_Cfg_Init(void)
{
    usrCfg.uc_gpioSwResetPin = 5;
    usrCfg.uc_maxStns = 64;
    usrCfg.uc_mfgDataLocation = 0xffffff70;
    usrCfg.uc_StrictShareMode = 1;
#ifdef AP31_SC
    usrCfg.us_GOnlyModeErpEnable = 1;
    usrCfg.us_NoCalibration = 1;
    usrCfg.us_StrictOpenMode = 1;
#endif
}

extern int AP_Init(void);
void ResetButtonHandler(ApEvtMsg_t *msg);

/******************************************************************************
 * 
 * Name:  
 * 
 * Description: 
 *     
 * 
 * Conditions For Use: 
 *    None. 
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/
#ifndef AP31_SC
void root( void )
{
    unsigned int SubID;

#ifdef ETHERSWITCH_IN_BOOT
    extern cyg_sem_t ip_ready;
#endif

    usr_Cfg_Init();
    AP_Init();
#ifdef ETHERSWITCH
#ifdef ETHERSWITCH_IN_OP
    etherSwitch_Init();
    msi_wl_EthMIIEnable();
#endif
    {
        extern unsigned char ether_port_down;
        ether_port_down = 0;
        initiate_dhcp(1);
    }
#endif
#ifdef ETHERSWITCH_IN_BOOT
    SetIPAddr();
    cyg_semaphore_post (&ip_ready);
#endif
    bridge_Init();
    bridge_Start();

    apctlGPIOInit(0xfaf0); /* LED and SW Reset */
    apEvtSub(APEVT_RST_BTN_PRESSED,(void *)&ResetButtonHandler, &SubID);
    dsPort_Init();

#ifndef NO_ECOS_TCP_IP_STACK
    MfgInit();
    winsInit();
    winxStart();
#endif

#ifdef RF_POWERDOWN_BOOT
    msi_wl_PowerupRF();
#endif
}
#endif
/******************************************************************************
 * 
 * Name:  
 * 
 * Description: 
 *     
 * 
 * Conditions For Use: 
 *    None. 
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/

cyg_sem_t init_ready;
void wait_init(void)
{
    //cyg_semaphore_wait(&init_ready);
}
void wait_init_init(void)
    {
        //cyg_semaphore_init(&init_ready, 0);
    }
void wait_init_post(void)
    {
        //cyg_semaphore_post(&init_ready);
    } 
   
    
externC void
cyg_user_start( void )
{
	//unsigned int SubID;
	//wait_init_init();
     usr_Cfg_Init();	
    root();
     //msi_wl_EthMIIEnable(); // for WGX102
     //apEvtSub(APEVT_RST_BTN_PRESSED,(void *)&ResetButtonHandler, &SubID);
      dsPort_Init();
}
#if 0
void perror(const char * str)
{}
#endif
void ResetButtonHandler(ApEvtMsg_t *msg)
{
    static int start_rb = 0;
    static long then_rb;

    if (!start_rb)
    {
        /* Ignore spurious interrupt at reboot */
        if(msg->evtTimeStamp < 3) {
            return;
        }

        start_rb = 1;
        then_rb = msg->evtTimeStamp;
    }
    else
    {
        if ((msg->evtTimeStamp - then_rb) > (5*83)) {
            ResetToFactorySettings();
        }

        Reset();
    }    
}                    


/* EOF aproot.c */
