#include <stdio.h>
#include "wltypes.h"
#include "IEEE_types.h"

#include "uemf.h"
#include "wsIntrn.h"
#include "Mrvap.h"
#include "AspDef.h"
#include "ap_api.h"

/* Antenna definitions. */
#define  AP_ANT_DIVERSITY       0x00 /* antenna mode  */
#define  AP_ANT_A               0x01 /* antenna mode  */
#define  AP_ANT_B               0x02 /* antenna mode  */
#define  RX_ANTENNA             0x00 /* which antenna */
#define  TX_ANTENNA             0x01 /* which antenna */

#define DECLARE_ASP(x) \
        static int x(int eid, webs_t wp, int argc, char_t **argv)
#define IMPLEMENT_ASP(x) DECLARE_ASP(x)
#define DECLARE_0_ASP_ARGS
#define DECLARE_1_ASP_ARGS                                         \
          char_t *arg1;                                            \
          if(ejArgs(argc, argv, T("%s %s"), &arg1) < 1) {          \
            websError(wp, 400, T("Insufficient args\n"));          \
            return -1;                                             \
          }
#define DECLARE_2_ASP_ARGS                                         \
          char_t *arg1, *arg2;                                     \
          if(ejArgs(argc, argv, T("%s %s"), &arg1, &arg2) < 2) {   \
            websError(wp, 400, T("Insufficient args\n"));          \
            return -1;                                             \
          }
#define DEFINE_ASP(x) \
		websAspDefine(T(#x), x);
//extern void GetSdkVersion(char *);
DECLARE_ASP(asp_channel_list);
DECLARE_ASP(asp_AP_list);
DECLARE_ASP(asp_wds_mode);
DECLARE_ASP(asp_get_disable_assoc);
DECLARE_ASP(asp_get_wds_option);
DECLARE_ASP(asp_ssid);
DECLARE_ASP(asp_firmware_version);
DECLARE_ASP(asp_open_ssid_en_state);
DECLARE_ASP(asp_rf_preamble_option);
DECLARE_ASP(asp_tx_antenna_mode);
DECLARE_ASP(asp_rx_antenna_mode);
DECLARE_ASP(asp_data_rate_b);
DECLARE_ASP(asp_data_rate_g);
DECLARE_ASP(asp_rf_channel);
DECLARE_ASP(asp_frag_threshold);
DECLARE_ASP(asp_rts_threshold);
DECLARE_ASP(asp_beacon_period);
DECLARE_ASP(asp_dtim_period);
DECLARE_ASP(asp_basic_data_rates);
DECLARE_ASP(asp_auth_mode);
DECLARE_ASP(asp_privacy_option);
DECLARE_ASP(asp_key_index);
DECLARE_ASP(asp_key_size);
DECLARE_ASP(asp_key_value);
DECLARE_ASP(asp_wpa_mode);
DECLARE_ASP(asp_wpa_encr_method);
DECLARE_ASP(asp_bridge_mac);
DECLARE_ASP(asp_rsn_stats);
DECLARE_ASP(asp_grp_rekey_time);
DECLARE_ASP(asp_dhcp_mode);
DECLARE_ASP(asp_ip_addr);
DECLARE_ASP(asp_accept_any_station);
DECLARE_ASP(asp_filter_list);
DECLARE_ASP(asp_sta_list);
DECLARE_ASP(asp_sta_list_cnt);
DECLARE_ASP(asp_error_message);
DECLARE_ASP(asp_error_redirect_url);
DECLARE_ASP(asp_get_privacy_option);
DECLARE_ASP(asp_get_wpa_mode);
DECLARE_ASP(asp_get_AP_mode);
DECLARE_ASP(asp_get_burst_mode);
DECLARE_ASP(asp_get_burst_rate);
DECLARE_ASP(asp_get_G_Protection_mode);
DECLARE_ASP(asp_get_wipod_mode);
#ifdef AP_SITE_SURVEY
DECLARE_ASP(asp_banner_create);
DECLARE_ASP(asp_get_site_survey);
#endif /* AP_SITE_SURVEY */


/*
 *	Strings to display error message and redirect URL
 *	error_message: Error message displayed on error dialog
 *	error_redirect_url: Redirected URL after the error message
 */

static char szErrorMessage[256] = "This is a sample error message.";
static char szRedirectUrl[256] = "radio.asp";

void dummy_AspDef(void) {
}

void asp_show_error_message(webs_t wp, char *message, char *redirect_url) {
    strcpy(szErrorMessage, message);
    strcpy(szRedirectUrl, redirect_url);
    websRedirect(wp, T("error.asp"));
}

void asp_define() {
    DEFINE_ASP(asp_channel_list);
    DEFINE_ASP(asp_AP_list);
    DEFINE_ASP(asp_wds_mode);
    DEFINE_ASP(asp_get_disable_assoc);
    DEFINE_ASP(asp_get_wds_option);
    DEFINE_ASP(asp_ssid);
    DEFINE_ASP(asp_firmware_version);
    DEFINE_ASP(asp_open_ssid_en_state);
    DEFINE_ASP(asp_rf_preamble_option);
    DEFINE_ASP(asp_tx_antenna_mode);
    DEFINE_ASP(asp_rx_antenna_mode);
    DEFINE_ASP(asp_data_rate_b);
    DEFINE_ASP(asp_data_rate_g);
    DEFINE_ASP(asp_rf_channel);
    DEFINE_ASP(asp_frag_threshold);
    DEFINE_ASP(asp_rts_threshold);
    DEFINE_ASP(asp_beacon_period);
    DEFINE_ASP(asp_dtim_period);
    DEFINE_ASP(asp_basic_data_rates);
    DEFINE_ASP(asp_auth_mode);
    DEFINE_ASP(asp_privacy_option);
    DEFINE_ASP(asp_key_index);
    DEFINE_ASP(asp_key_size);
    DEFINE_ASP(asp_key_value);
    DEFINE_ASP(asp_wpa_mode);
    DEFINE_ASP(asp_wpa_encr_method);
    DEFINE_ASP(asp_rsn_stats);
    DEFINE_ASP(asp_grp_rekey_time);
    DEFINE_ASP(asp_bridge_mac);
    DEFINE_ASP(asp_dhcp_mode);
    DEFINE_ASP(asp_ip_addr);
    DEFINE_ASP(asp_accept_any_station);
    DEFINE_ASP(asp_filter_list);
    DEFINE_ASP(asp_sta_list);
    DEFINE_ASP(asp_sta_list_cnt);
    DEFINE_ASP(asp_error_message);
    DEFINE_ASP(asp_error_redirect_url);
    DEFINE_ASP(asp_get_privacy_option);
    DEFINE_ASP(asp_get_wpa_mode);
    DEFINE_ASP(asp_get_AP_mode);
    DEFINE_ASP(asp_get_burst_mode);
    DEFINE_ASP(asp_get_burst_rate);
    DEFINE_ASP(asp_get_G_Protection_mode);
    DEFINE_ASP(asp_get_wipod_mode);
#ifdef AP_SITE_SURVEY
    DEFINE_ASP(asp_banner_create);
    DEFINE_ASP(asp_get_site_survey);
#endif /* AP_SITE_SURVEY */
}
IMPLEMENT_ASP(asp_channel_list){
    /* get channel */
    unsigned short nData, i;
    unsigned char min, max, def;
    DECLARE_1_ASP_ARGS;
    if ( domainGetInfo(&min, &max, &def) != OS_SUCCESS )
    {
        min = 1;
        max = 14;
    }

    if ( ApCmdGetProc(APCMD_GET_RF_CHANNEL, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }

    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"35%%\">RF Channel</td>"));
    websWrite(wp, T("<td width=\"65%%\"><select size=\"1\" name=\"Channel\">"));
    for ( i=min; i<=max;i++ )
    {
        if ( nData == i )
        {
            websWrite(wp, T("<option selected>Channel %d</option>"), i);
        }
        else
        {
            websWrite(wp, T("<option>Channel %d</option>"), i);
        }
    }
    websWrite(wp, T("</select></td>"));
    websWrite(wp, T("</tr>"));
}

IMPLEMENT_ASP(asp_AP_list) {
#ifdef WDS_FEATURE
    USHORT  nBufSize = MAX_WDS_AP_LIST*6+2, nCount;
    UCHAR   *pBuf, *pChar;

    // Get Filter Station List 
    //ApCmdGetProc(APCMD_GET_FILTER_BUFSIZE, (char*)&nBufSize);
    if ( 1 )
    {//nBufSize >= MIN_FILTER_LIST_BUF_SIZE) {
        pBuf = malloc(nBufSize);
        *((USHORT*)pBuf) = nBufSize;
        if ( ApCmdGetProc(APCMD_GET_WDS_LIST, (char*)pBuf) == STATUS_FAIL )
        {
            free (pBuf);
            pBuf = 0;
        }
    }
    else
    {
        pBuf = NULL;
    }

    if ( pBuf!=0 )
    {
        nCount = pBuf[0];
        pChar = pBuf+sizeof(USHORT);
        while ( nCount )
        {
            websWrite(wp, T("  <tr>\n"));
            websWrite(wp, T("    <td width=\"25%c\" align=\"center\">%d</td>\n"),
                      0x25, pBuf[0]-nCount);
            websWrite(wp, T("    <td width=\"75%c\"><input type=\"text\" name=\"WdsAp%d\" "
                            "value=\"%02X:%02X:%02X:%02X:%02X:%02X\" size=\"25\"></td>\n"),
                      0x25, pBuf[0]-nCount, *pChar, *(pChar+1), *(pChar+2), *(pChar+3),
                      *(pChar+4), *(pChar+5));
            websWrite(wp, T("  </tr>\n"));
            pChar += 6;
            nCount--;
        }
        free (pBuf);
    }
    nCount = pBuf[0];
    while ( nCount < MAX_WDS_AP_LIST )
    {
        websWrite(wp, T("  <tr>\n"));
        websWrite(wp, T("    <td width=\"25%c\" align=\"center\">%d</td>\n")
                  ,0x25, nCount);
        websWrite(wp, T("    <td width=\"75%c\"><input type=\"text\" name=\"WdsAp%d\" "
                        "value=\"00:00:00:00:00:00\" size=\"25\"></td>\n"),0x25, nCount);
        websWrite(wp, T("  </tr>\n"));
        nCount++;
    }
#endif
    return 1;
}

IMPLEMENT_ASP(asp_wds_mode) {
    UCHAR chData, chInput;
    DECLARE_1_ASP_ARGS;
#ifdef WDS_FEATURE
    if ( ApCmdGetProc(APCMD_GET_WDS_MODE, (char*)&chData) == STATUS_FAIL )
    {
        chData = (UCHAR)DATA_ERROR;
    }
    if ( strcmp(arg1, "disable") == 0 )
    {
        chInput = WDS_MODE_DISABLE;
    }
    else if ( strcmp(arg1, "static") == 0 )
    {
        chInput = WDS_MODE_STATIC;
    }
    else if ( strcmp(arg1, "dynamic") == 0 )
    {
        chInput = WDS_MODE_DYNAMIC;
    }
#endif
    return websWrite(wp, T(chData==chInput?"selected":""));
}

IMPLEMENT_ASP(asp_get_disable_assoc) {
    UCHAR chData;
    DECLARE_0_ASP_ARGS;
#ifdef WDS_FEATURE
    if ( ApCmdGetProc(APCMD_GET_DISABLE_ASSOC, &chData) == STATUS_FAIL)
    {
        chData = FALSE;
    }
#endif
    return websWrite(wp, T(chData?"checked":"")); 
}

IMPLEMENT_ASP(asp_get_wds_option) {
    UCHAR chData;
    DECLARE_0_ASP_ARGS;
#ifdef WDS_FEATURE
    if ( ApCmdGetProc(APCMD_GET_WDS_OPTION, &chData) == STATUS_FAIL)
    {
        chData = FALSE;
    }
#endif
    return websWrite(wp, T(chData?"checked":"")); 
}

IMPLEMENT_ASP(asp_ssid) {
    char buf[64];
    unsigned char sLen, i, j;
    char buf2[100];
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_SSID, buf) == FAIL )
    {
        return websWrite(wp, T(""));
    }
    sLen = strlen(buf);
    memset(buf2, 0, 100);
    for ( i=0, j=0; i < sLen; i++ )
    {
        if ( buf[i]==0x22 )
        {
            buf2[j] = '&';
            j++;
            buf2[j] = '#';
            j++;
            buf2[j] = '3';
            j++;
            buf2[j] = '4';
            j++;
            buf2[j] = ';';
            j++;
        }
        else
        {
            buf2[j] = buf[i];
            j++;
        }
    }
    return websWrite(wp, T(buf2));
}

IMPLEMENT_ASP(asp_get_wipod_mode) {

    UCHAR apicmdbuf_wimode_body;/* This needs to be larger for other modes */
    UCHAR wiMode;
	DECLARE_1_ASP_ARGS;

#if defined(WIPOD)	
	if (ApCmdGetProc(APCMD_GET_WIPOD_MODE, (UCHAR *)&apicmdbuf_wimode_body) == STATUS_FAIL) {
		wiMode = 0;
	}
    wiMode = (!(apicmdbuf_wimode_body & WIPOD_TYPE_AP))? WIPOD_MODE_CLIENT_BRIDGE:0;

	if(strcmp(arg1, "string") == 0)
	{
		return websWrite(wp, T(wiMode?"WB":"AP"));
	}
	else if(strcmp(arg1, "WB") == 0) 
	{
		return websWrite(wp, T(wiMode?"checked":""));
	} 
#endif
	return websWrite(wp, T(wiMode?"":"checked"));
}



IMPLEMENT_ASP(asp_firmware_version) {
    char buf[64];
    DECLARE_0_ASP_ARGS;
#if 1
    if ( ApCmdGetProc(APCMD_GET_FIRMWARE_VERSION, buf) == STATUS_FAIL )
    {
        strcpy(buf, "Not Available");
    }
#else
    //GetSdkVersion(buf);
#endif
    return websWrite(wp, T(buf));
}

IMPLEMENT_ASP(asp_open_ssid_en_state) {
    char chData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_OPEN_SSID_EN_STATE, &chData)==STATUS_FAIL )
    {
        chData = FALSE;
    }

    return websWrite(wp, T(chData?"checked":"")); 
}

IMPLEMENT_ASP(asp_rf_preamble_option) {
    char chData, inData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_RF_PREAMBLE_OPTION, &chData)==STATUS_FAIL )
    {
        chData = (char)DATA_ERROR;
    }

    if ( strcmp(arg1, "auto") == 0 )
    {
        inData = PREAMBLE_AUTO_SELECT;
    }
    else if ( strcmp(arg1, "short") == 0 )
    {
        inData = PREAMBLE_SHORT;
    }
    else if ( strcmp(arg1, "long") == 0 )
    {
        inData = PREAMBLE_LONG;
    }

    return websWrite(wp, T(chData==inData?"selected":""));
}

IMPLEMENT_ASP(asp_tx_antenna_mode) {
    unsigned short nData, inData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ANTENNA_MODE, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }

    if ( strcmp(arg1, "both") == 0 )
    {
        inData = AP_ANT_DIVERSITY;
    }
    else if ( strcmp(arg1, "ant1") == 0 )
    {
        inData = AP_ANT_A;
    }
    else if ( strcmp(arg1, "ant2") == 0 )
    {
        inData = AP_ANT_B;
    }

    return websWrite(wp, T(((nData&0xF0)>>4)==inData?"selected":""));
}

IMPLEMENT_ASP(asp_rx_antenna_mode) {
    unsigned short nData, inData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ANTENNA_MODE, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }

    if ( strcmp(arg1, "both") == 0 )
    {
        inData = AP_ANT_DIVERSITY;
    }
    else if ( strcmp(arg1, "ant1") == 0 )
    {
        inData = AP_ANT_A;
    }
    else if ( strcmp(arg1, "ant2") == 0 )
    {
        inData = AP_ANT_B;
    }

    return websWrite(wp, T((nData&0x0F)==inData?"selected":""));
}

IMPLEMENT_ASP(asp_data_rate_b) {
    unsigned char nData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_TX_DATA_RATE, (char*)&nData) == STATUS_FAIL )
    {
        nData = (unsigned char)DATA_ERROR;
    }

    return websWrite(wp, T((unsigned char)atoi(arg1)==nData?"selected":""));
}

IMPLEMENT_ASP(asp_data_rate_g) {
    unsigned char nData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_TX_DATA_RATE_G, (char*)&nData) == STATUS_FAIL )
    {
        nData = (unsigned char)DATA_ERROR;
    }

    return websWrite(wp, T((unsigned char)atoi(arg1)==nData?"selected":""));
}

IMPLEMENT_ASP(asp_rf_channel) {
    unsigned short nData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_RF_CHANNEL, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }

    return websWrite(wp, T((nData)==atoi(arg1)?"selected":""));
}

IMPLEMENT_ASP(asp_frag_threshold) {
    USHORT nData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_FRAG_THRESHOLD, (char*)&nData) == STATUS_FAIL )
    {
        nData = 0;
    }
    if ( nData < FRAG_THRESHOLD_MIN )
    {
        nData = FRAG_THRESHOLD_MIN;
    }
    if ( nData > FRAG_THRESHOLD_MAX )
    {
        nData = FRAG_THRESHOLD_MAX;
    }

    return websWrite(wp, T("%d"), nData);
}

IMPLEMENT_ASP(asp_rts_threshold) {
    USHORT nData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_RTS_THRESHOLD, (char*)&nData) == STATUS_FAIL )
    {
        nData = 0;
    }
    if ( nData > RTS_THRESHOLD_MAX )
    {
        nData = RTS_THRESHOLD_MAX;
    }

    return websWrite(wp, T("%d"), nData);
}

IMPLEMENT_ASP(asp_beacon_period) {
    ULONG lData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_BEACON_PERIOD, (char*)&lData) == STATUS_FAIL )
    {
        lData = 0;
    }

    return websWrite(wp, T("%d"), lData);
}

IMPLEMENT_ASP(asp_dtim_period) {
    ULONG lData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_DTIM_PERIOD, (char*)&lData) == STATUS_FAIL )
    {
        lData = 0;
    }

    return websWrite(wp, T("%d"), lData);
}

/*
 *	The basic data rates of 802.11B and 802.11G are different.
 *  The GUI need to be changed for it.  The basic data rates
 *	of 802.11G are used at the time being.
 */
IMPLEMENT_ASP(asp_basic_data_rates) {
    UCHAR dataRates[16];
    int i;
    char szDisplay[16];
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_BASIC_DATA_RATES_G, (char*)dataRates) == STATUS_FAIL )
    {
        memset(dataRates, 0, sizeof(dataRates));
    }

    /*
     *	The Basic Data Rates are packed in an 8 bytes unsigned char
     *  array.  The MSB of each byte indicates whether this mode is
     *	enabled.  The rest of bits indcate the basic date rates,
     *  which is the two-time of number displayed in the web page.
     *  Enabling the higher data rate also enable the date rates
     *  lower than it.
     */
    for ( i = 0, strcpy(szDisplay, ""); i < sizeof(dataRates)/sizeof(dataRates[0]); i++ )
    {
        if ( (dataRates[i] & 0x7F) == atoi(arg1) )
        {
            strcpy(szDisplay, (dataRates[i]&0x80)?"checked":"");
            break;
        }
    }

    return websWrite(wp, T(szDisplay));
}

IMPLEMENT_ASP(asp_auth_mode) {
    UCHAR chData, chInput;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_AUTH_MODE, (char*)&chData) == STATUS_FAIL )
    {
        chData = (UCHAR)DATA_ERROR;
    }

    if ( strcmp(arg1, "open") == 0 )
    {
        chInput = OPEN_SYSTEM_ONLY;
    }
    else if ( strcmp(arg1, "shared") == 0 )
    {
        chInput = SHARED_KEY_ONLY;
    }
    else if ( strcmp(arg1, "both") == 0 )
    {
        chInput = OPEN_SYSTEM_AND_SHARED_KEY;
    }

    return websWrite(wp, T(chData==chInput?"selected":""));
}

IMPLEMENT_ASP(asp_privacy_option) {
    UCHAR chData, chInput;
    char szDisplay[16];
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_PRIVACY_OPTION, &chData) == STATUS_FAIL )
    {
        chData = (UCHAR) DATA_ERROR;
    }

    if ( strcmp(arg1, "not") == 0 )
    {
        chInput = DATA_ENCRYPT_NOT_REQUIRED;

    }
    else
    {
        chInput = FULL_DATA_ENCRYPT_REQUIRED;

    }

    if ( chData == DATA_ENCRYPT_NOT_REQUIRED )
    {
        WepEnabled=FALSE;
        sprintf(szDisplay, "%s", chInput==chData?"selected":"");
    }
    else
    {
        WepEnabled=TRUE;
        sprintf(szDisplay, "%s", chInput!=DATA_ENCRYPT_NOT_REQUIRED?"selected":"");
    }

    return websWrite(wp, T("%s"), szDisplay);
}

IMPLEMENT_ASP(asp_key_index) {
    WEP_KEY wep;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_DEFAULT_WEP_KEYS, (char*)&wep) == STATUS_FAIL )
    {
        memset(&wep, 0, sizeof(WEP_KEY));
    }

    return websWrite(wp, T(wep.TxKeyIndex+1==atoi(arg1)?"selected":""));
}

IMPLEMENT_ASP(asp_key_size) {
    WEP_KEY wep;
    USHORT nData, inData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_DEFAULT_WEP_KEYS, (char*)&wep) == STATUS_FAIL )
    {
        memset(&wep, 0, sizeof(WEP_KEY));
    }

    switch ( wep.TxKeyIndex )
    {
    case 0:
        nData = wep.keyType0;
        break;
    case 1:
        nData = wep.keyType1;
        break;
    case 2:
        nData = wep.keyType2;
        break;
    case 3:
        nData = wep.keyType3;
        break;
    }

    if ( strcmp(arg1, "not") == 0 )
    {
        inData = WEP_NOT_SET;
    }
    else if ( strcmp(arg1, "40") == 0 )
    {
        inData = WEP_40_BIT;
    }
    else if ( strcmp(arg1, "104") == 0 )
    {
        inData = WEP_104_BIT;
    }

    return websWrite(wp, T(nData==inData?"selected":""));
}

IMPLEMENT_ASP(asp_key_value) {
    WEP_KEY wep;
    unsigned char *pKey;
    char szDisplay[11];
    int i;
    DECLARE_1_ASP_ARGS;
/*
    if (ApCmdGetProc(APCMD_GET_DEFAULT_WEP_KEYS, (char*)&wep) == STATUS_FAIL) {
        memset(&wep, 0, sizeof(WEP_KEY));
    }

    switch(atoi(arg1)) {
    case 1:
        pKey = wep.keyValue0;
        break;
    case 2:
        pKey = wep.keyValue1;
        break;
    case 3:
        pKey = wep.keyValue2;
        break;
    case 4:
        pKey = wep.keyValue3;
        break;
    }

    for (i = 0; i < 26; i++) {
        if (i % 2 == 0)
            sprintf(szDisplay + i, "%X", (*(pKey+i/2)&0xF0)>>4);
        else
            sprintf(szDisplay + i, "%X", (*(pKey+i/2)&0x0F));
    }
    for (i = 26; i > 0; i--)
        if (szDisplay[i - 1] != '0')
            break;
*/
    /* Uncomment the following line to display the "*" for WEP Keys */
    memset(szDisplay, '*', 10 * sizeof(char)); 
    szDisplay[10] = '\0';

    return websWrite(wp, T("%s"), szDisplay);
}

IMPLEMENT_ASP(asp_wpa_mode)
{
    UCHAR chData, chInput;
    APICMDBUF_GET_RSN_CFG_AUTH_SUITE auth_suites;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_PRIVACY_TBL_RSN_ENABLED, (char*)&chData) == STATUS_FAIL )
    {
        chData = 0; 
    }
    if ( chData==1 )
    {
        WpaEnabled=TRUE;    
    }
    else
    {
        WpaEnabled=FALSE; 
    }

    if (WpaEnabled)
    {
/*
        if (ApCmdGetProc(APCMD_GET_RSN_CFG_AUTH_SUITE, (char*)&auth_suites) == STATUS_FAIL)
    {
            chData = 0; 
        }
*/        
        auth_suites.cmdCode = APCMD_GET_RSN_CFG_AUTH_SUITE;
        auth_suites.cmdBodyLen = sizeof(APICMDBUF_GET_RSN_CFG_AUTH_SUITE)-BUF_HDR_LEN;
        auth_suites.seqNum = 1;
        apctl(&auth_suites);

        if (strcmp(arg1, "WPA-PSK") == 0)
        {
            chInput = 2;
        }
        else if (strcmp(arg1, "WPA-802.1x") == 0)
        {
        chInput = 1;
    }
    else
    {
        chInput = 0;
    }
    }

    return websWrite(wp, T(auth_suites.AuthSuites[3]==chInput?"selected":""));
}

IMPLEMENT_ASP(asp_wpa_encr_method) {
    UCHAR chSuites[4];
    UCHAR chInput = 0;
    APICMDBUF_GET_RSN_CFG_UNICAST_CIPHERS cipher_mode;
    DECLARE_1_ASP_ARGS;
/*
    if (ApCmdGetProc(APCMD_GET_RSN_CFG_UNICAST_CIPHER, (char*)chSuites) == STATUS_FAIL)
    {
        chSuites[3] = 0;
    }
*/    
    cipher_mode.cmdCode = APCMD_GET_RSN_CFG_UNICAST_CIPHERS;
    cipher_mode.cmdBodyLen = sizeof(APICMDBUF_GET_RSN_CFG_UNICAST_CIPHERS)-BUF_HDR_LEN;
    cipher_mode.seqNum = 1;
    apctl(&cipher_mode);

    if (strcmp(arg1, "TKIP") == 0)
    {
        chInput = 2;
    }
    if (strcmp(arg1, "CCMP") == 0)
    {
        chInput = 4;
    }
    else
        chInput = 0;


    return websWrite(wp, T(cipher_mode.UnicastCipher[3]==chInput?"selected":""));
}

IMPLEMENT_ASP(asp_rsn_stats) {
    APICMDBUF_GET_RSN_STATS rsnStats;
    ULONG lData = 0;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_RSN_STATS, (char*)&rsnStats) == STATUS_FAIL )
    {
        lData = 0;
    }
    else
    {
        if ( strcmp(arg1, "icv_errors") == 0 )
        {
            lData = rsnStats.TKIPICVErrors;
        }
        else if ( strcmp(arg1, "local_mic_failures") == 0 )
        {
            lData = rsnStats.TKIPLocalMICFailures;
        }
        else if ( strcmp(arg1, "remote_mic_failures") == 0 )
        {
            lData = rsnStats.TKIPRemoteMICFailures;
        }
        else if ( strcmp(arg1, "counter_measures_invoked") == 0 )
        {
            lData = rsnStats.TKIPCounterMeasuresInvoked;
        }
    }

    return websWrite(wp, T("%u"), lData); 
}

IMPLEMENT_ASP(asp_grp_rekey_time) {
    APICMDBUF_GET_RSN_CFG rsnCfg;
    ULONG lData = 0;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_RSN_CFG, (char*)&rsnCfg) == STATUS_FAIL )
    {
        lData = 0;
    }
    else
    {
        lData = rsnCfg.GroupRekeyTime;
    }

    return websWrite(wp, T("%u"), lData); 
}

IMPLEMENT_ASP(asp_bridge_mac) {
    unsigned char mac[6];
    DECLARE_1_ASP_ARGS;

    memset(mac, 0, 6);
    if ( strcmp(arg1, "wan_mac") == 0 )
    {
        //GetWanMac(mac);
    }
    else if ( strcmp(arg1, "lan_mac") == 0 )
    {
        //GetLanMac(mac);
    }
    else if ( strcmp(arg1, "gw_wan_mac") == 0 )
    {
        //GetGwWanMac(mac);
    }
    else if ( strcmp(arg1, "gw_lan_mac") == 0 )
    {
        //GetGwLanMac(mac);
    }
    else if ( strcmp(arg1, "wlan_mac") == 0 )
    {
        //GetWlanMac(mac);
    }

    return websWrite(wp, T("%02X:%02X:%02X:%02X:%02X:%02X"), mac[0], mac[1],
                     mac[2], mac[3], mac[4], mac[5]);
}

IMPLEMENT_ASP(asp_dhcp_mode) {
    UCHAR pBuf[16];
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ETH_IP_CONFIG, (char*)pBuf) == STATUS_FAIL )
    {
        memset(pBuf, 0, sizeof(pBuf));
    }

    if ( strcmp(arg1, "enabled") == 0 )
    {
        return websWrite(wp, T((ULONG)(*(ULONG*)pBuf)?"checked":""));
    }
    else
    {
        return websWrite(wp, T((ULONG)(*(ULONG*)pBuf)?"":"checked"));
    }
}

IMPLEMENT_ASP(asp_ip_addr) {
    UCHAR pBuf[16];
    int nFirst;
    DECLARE_2_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ETH_IP_CONFIG, (char*)pBuf) == STATUS_FAIL )
    {
        memset(pBuf, 0, sizeof(pBuf));
    }

    if ( strcmp(arg1, "ip") == 0 )
    {
        /* IP Address starts from the 4th byte */
        nFirst = 4;
    }
    else if ( strcmp(arg1, "mask") == 0 )
    {
        /* Subnet Mask starts from the 8th byte */
        nFirst = 8;
    }
    else if ( strcmp(arg1, "gateway") == 0 )
    {
        /* Default Getway IP Address starts from 12 byte */
        nFirst = 12;
    }

    return websWrite(wp, T("%u"), pBuf[nFirst + atoi(arg2) - 1]);
}

IMPLEMENT_ASP(asp_accept_any_station) {
    USHORT nBufSize = 0;
    UCHAR *pBuf = NULL;
    int isChecked;
    DECLARE_0_ASP_ARGS;

    /*
     *	"Accept Any Station" is determined by number of entry in the filter
     *	list, so the whole list is retrieved.  Further improvement of the
     *	interface is recommanded.
     */
    if ( ApCmdGetProc(APCMD_GET_WLAN_FILTER_LIST, (char*)&nBufSize) == STATUS_FAIL )
    {
        nBufSize = 0;
    }

    /* Get the filter list only when a least one entry is available*/
    if ( nBufSize >= MIN_FILTER_LIST_BUF_SIZE )
    {
        pBuf = malloc(nBufSize);
        *((USHORT*)pBuf) = nBufSize;
        if ( ApCmdGetProc(APCMD_GET_WLAN_FILTER_LIST, (char*) pBuf) != STATUS_FAIL )
        {
            isChecked = (*(pBuf+1) <= 0) && (*pBuf <= 0);
        }
        free(pBuf);
    }
    else
    {
        isChecked = 1;
    }

    return websWrite(wp, T(isChecked?"checked":""));
}

/*
 *	The following function is directly adopted from the original code segment
 *	in Mvrap.c.
 */
IMPLEMENT_ASP(asp_filter_list) {
    USHORT  nBufSize =0, nCount;
    UCHAR   *pBuf, *pChar;

    // Get Filter Station List 
    ApCmdGetProc(APCMD_GET_WLAN_FILTER_LIST, (char*)&nBufSize);
    if ( nBufSize >= MIN_FILTER_LIST_BUF_SIZE )
    {
        pBuf = malloc(nBufSize);
        *((USHORT*)pBuf) = nBufSize;
        if ( ApCmdGetProc(APCMD_GET_WLAN_FILTER_LIST, (char*)pBuf) == STATUS_FAIL )
        {
            free (pBuf);
            pBuf = 0;
        }
    }
    else
    {
        pBuf = NULL;
    }

    nCount = 1;
    if ( pBuf!=0 )
    {
        pChar = pBuf+sizeof(USHORT);
        while ( (nCount * 6)< nBufSize )
        {
            websWrite(wp, T("  <tr>\n"));
            websWrite(wp, T("    <td width=\"25%c\" align=\"center\">%d</td>\n"),
                      0x25, nCount);
            websWrite(wp, T("    <td width=\"75%c\"><input type=\"text\" name=\"Sta%d\" "
                            "value=\"%02X:%02X:%02X:%02X:%02X:%02X\" size=\"25\"></td>\n"),
                      0x25, nCount, *pChar, *(pChar+1), *(pChar+2), *(pChar+3),
                      *(pChar+4), *(pChar+5));
            websWrite(wp, T("  </tr>\n"));
            pChar += 6;
            nCount ++;
        }
        free (pBuf);
    }
    while ( nCount <= MAX_STA_IN_FILTER_LIST )
    {
        websWrite(wp, T("  <tr>\n"));
        websWrite(wp, T("    <td width=\"25%c\" align=\"center\">%d</td>\n")
                  ,0x25, nCount);
        websWrite(wp, T("    <td width=\"75%c\"><input type=\"text\" name=\"Sta%d\" "
                        "value=\"00:00:00:00:00:00\" size=\"25\"></td>\n"),0x25, nCount);
        websWrite(wp, T("  </tr>\n"));
        nCount++;
    }

    return 1;
}

/*
 *	The following function is directly adopted from the original code segment
 *	in Mvrap.c.
 */
#ifdef STA_INFO_DB
typedef struct RATE_t
{
    UINT8 *RateS;
}RATE_t;
RATE_t rate[14] = {"1M","2M","5.5M","11M","22M",
    "6M","9M","12M","18M","24M","36M","48M","54M","72M"};
#endif
IMPLEMENT_ASP(asp_sta_list) {
    USHORT  nBufSize =0, nCount;
    char    *pBuf;
    UCHAR   *pChar;
    DECLARE_0_ASP_ARGS;

    // Get STA List 
    ApCmdGetProc(APCMD_GET_STA_LIST, (char*)&nBufSize);
    if ( nBufSize >= MIN_STA_LIST_BUF_SIZE )
    {
        pBuf = malloc(nBufSize);
        *((USHORT*)pBuf) = nBufSize;
        if ( ApCmdGetProc(APCMD_GET_STA_LIST, pBuf) == STATUS_FAIL )
        {
            free(pBuf);
            pBuf = 0;
        }
    }
    else
    {
        pBuf = NULL;
    }
    websWrite(wp, T("  <tr>\n"));
#ifdef STA_INFO_DB
    websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"No");
    websWrite(wp, T("    <td width=\"30%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"MAC Address");
    websWrite(wp, T("    <td width=\"15%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Status");
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Mode");
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Rate");
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Signal Quality");
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"RSSI");
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Power Save");
#else                                                                                          
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"No");
    websWrite(wp, T("    <td width=\"50%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"MAC Address");
    websWrite(wp, T("    <td width=\"40%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Status");
#endif                                                                                         
    websWrite(wp, T("  </tr>\n"));

#ifdef STA_INFO_DB
    nBufSize =  pBuf[0] * sizeof(STA_INFO) + 2 ;
    if ( pBuf != NULL )
    {
        nCount = 1;
        pChar = pBuf + sizeof(USHORT);
        while ( (nCount * sizeof(STA_INFO))< nBufSize )
        {
            websWrite(wp, T("  <tr>\n"));
            websWrite(wp, T("    <td width=\"5%c\" align=\"center\">%d</td>\n"),0x25, nCount);
            websWrite(wp, T("    <td width=\"30%c\" align=\"center\">%02X:%02X:%02X:%02X:%02X:%02X</td>\n"),
                      0x25, *pChar, *(pChar+1), *(pChar+2), *(pChar+3), *(pChar+4), *(pChar+5));                      
            websWrite(wp, T("    <td width=\"15%c\" align=\"center\">%s</td>\n"),
                      0x25, *(pChar+6)==FALSE? "Authenticated":"Associated");
            websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%s</td>\n"),0x25, *(pChar+7)?(*(pChar+7)==1?"g":"g/b"):"b");
            websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%s</td>\n"),0x25, rate[*(pChar+8)].RateS);
            websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%d</td>\n"),0x25, *(pChar+9));
            websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%d</td>\n"),0x25, *(pChar+11));
            websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%s</td>\n"),0x25, *(pChar+12)?"Yes":"No");
            websWrite(wp, T("  </tr>\n"));
            pChar += sizeof(STA_INFO);
            nCount ++;
        }
        free(pBuf);
    }

#else
    if ( pBuf != NULL )
    {
        nCount = 1;
        pChar = pBuf + sizeof(USHORT);
        while ( (nCount * 8)< nBufSize )
        {
            websWrite(wp, T("  <tr>\n"));
            websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%d</td>\n"),0x25, nCount);
            websWrite(wp, T("    <td width=\"50%c\" align=\"center\">%02X:%02X:%02X:%02X:%02X:%02X</td>\n"),
                      0x25, *pChar, *(pChar+1), *(pChar+2), *(pChar+3), *(pChar+4), *(pChar+5));                      
            websWrite(wp, T("    <td width=\"40%c\" align=\"center\">%s</td>\n"),
                      0x25, *((USHORT*)(pChar+6))==FALSE? "Authenticated":"Associated");
            websWrite(wp, T("  </tr>\n"));
            pChar += 8;
            nCount ++;
        }
        free(pBuf);
    }
#endif
    return 1;
}

IMPLEMENT_ASP(asp_sta_list_cnt) {
    USHORT  nBufSize, nCount=0;
    char    *pBuf;
    UCHAR   *pChar;
    DECLARE_0_ASP_ARGS;

    // Get STA List 
    ApCmdGetProc(APCMD_STALIST_BUFSIZE, (char*)&nBufSize);
    if ( nBufSize >= MIN_STA_LIST_BUF_SIZE )
    {
        pBuf = malloc(nBufSize);
        *((USHORT*)pBuf) = nBufSize;
        if ( ApCmdGetProc(APCMD_GET_STA_LIST, pBuf) == STATUS_FAIL )
        {
            free(pBuf);
            pBuf = 0;
        }
    }
    else
    {
        pBuf = NULL;
    }

    if ( pBuf != NULL )
    {
#if defined(AP31CLIENT) || defined(AP31E) || defined(AP_PCI)
        nCount = *((USHORT *)&pBuf[0]);
#else
        nCount = ((USHORT)pBuf[0] << 8 ) + (USHORT)pBuf[1];
#endif        
        free(pBuf);
    }

    return websWrite(wp, "%d", nCount);;
}
IMPLEMENT_ASP(asp_error_message) {
    DECLARE_0_ASP_ARGS;

    return websWrite(wp, "%s", szErrorMessage);
}

IMPLEMENT_ASP(asp_error_redirect_url) {
    DECLARE_0_ASP_ARGS;

    return websWrite(wp, "%s", szRedirectUrl);
}

IMPLEMENT_ASP(asp_get_privacy_option) {

    UCHAR chData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_PRIVACY_OPTION, &chData) == STATUS_FAIL )
    {
        chData = (UCHAR) DATA_ERROR;
    }
    if ( chData == DATA_ENCRYPT_NOT_REQUIRED )
    {
        WepEnabled=FALSE; 
    }
    else
    {
        WepEnabled=TRUE; 
    }   
    return;
}

IMPLEMENT_ASP(asp_get_wpa_mode) {

    UCHAR chData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_PRIVACY_TBL_RSN_ENABLED, (char*)&chData) == STATUS_FAIL )
    {
        chData = 0; 
    }
    if ( chData==1 )
    {
        WpaEnabled=TRUE;    
    }
    else
    {
        WpaEnabled=FALSE; 
    }
    return;
}

IMPLEMENT_ASP(asp_get_AP_mode) {

    unsigned short nData, inData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_AP_MODE, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }

    if ( strcmp(arg1, "b_mode") == 0 )
    {
        inData = AP_MODE_B_ONLY;
    }
    else if ( strcmp(arg1, "g_mode") == 0 )
    {
        inData = AP_MODE_G_ONLY;
    }
    else if ( strcmp(arg1, "mix_mode") == 0 )
    {
        inData = AP_MODE_MIXED;
    }

    return websWrite(wp, T(nData==inData?"selected":""));

}

IMPLEMENT_ASP(asp_get_burst_mode) {

    unsigned char nData, inData;
    BURST_INFO BurstInfo;
    DECLARE_1_ASP_ARGS;
#ifdef BURST_MODE
    if ( ApCmdGetProc(APCMD_GET_BURST_MODE, (char*)&BurstInfo) == STATUS_FAIL )
    {
        nData = 0;
    }
    else
    {
        nData = BurstInfo.BurstMode;
    }

    if ( strcmp(arg1, "disable") == 0 )
    {
        inData = 0;
    }
    else if ( strcmp(arg1, "enable") == 0 )
        inData = 1;

#endif	
    return websWrite(wp, T(nData==inData?"selected":""));
}

IMPLEMENT_ASP(asp_get_burst_rate) {

    unsigned char nData;
    BURST_INFO BurstInfo;
    DECLARE_0_ASP_ARGS;
#ifdef BURST_MODE
    if ( ApCmdGetProc(APCMD_GET_BURST_MODE, (char*)&BurstInfo) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }
    else
    {
        nData=BurstInfo.BurstRate;
    }
#endif
    return websWrite(wp, T("%d"), nData);   

}

IMPLEMENT_ASP(asp_get_G_Protection_mode) {

    unsigned short nData, inData;
    unsigned char nData1;
    DECLARE_1_ASP_ARGS;
    if ( ApCmdGetProc(APCMD_GET_FORCE_PROTECTION_MODE, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }

#ifdef SELF_CTS
    if ( ApCmdGetProc(APCMD_GET_SELF_CTS, (char*)&nData1) == STATUS_FAIL )
    {
        nData1 = DATA_ERROR;
    }
    if (nData == 0xff) {
        nData = 1;
    }
    if( nData1 == 0 && nData == 0)
    {
        nData = 2; 
    }
#endif
    if ( strcmp(arg1, "onCTS") == 0 )
    {
        inData = 0;
    }
    else if ( strcmp(arg1, "off") == 0 )
    {
        inData = 1; 
    }
    else if ( strcmp(arg1, "onRTS") == 0 )
    {
        inData = 2; 
    }

    return websWrite(wp, T(nData==inData?"selected":""));

}

#ifdef AP_SITE_SURVEY
UINT32 stringToHtmlString(unsigned char *inBuf, 
                          int inBufLen,
                          unsigned char *outBuf, 
                          int outBufLen){
    unsigned char sLen, i, j;
    
    sLen = strlen(inBuf);
    if(sLen > inBufLen)
    {
        sLen = inBufLen;
    }
    for (i=0, j=0; i < sLen && j < outBufLen; i++)
    {
        if (*(inBuf+i)==0x22)
        {
            *(outBuf+j) = '&';
            j++;
            *(outBuf+j) = '#';
            j++;
            *(outBuf+j) = '3';
            j++;
            *(outBuf+j) = '4';
            j++;
            *(outBuf+j) = ';';
            j++;
        }
        else
        {
            *(outBuf+j) = *(inBuf+i);
            j++;
        }
    }
    return j;
}

IMPLEMENT_ASP(asp_banner_create) {

    int sp = 0;
    DECLARE_1_ASP_ARGS;

    if (strcmp(arg1, "WB31") == 0)
    {
        sp += websWrite(wp, T("<table border=\"1\" width=\"700\" bgcolor=\"#000000\" bordercolor=\"#C0C0C0\" cellspacing=\"0\"><tr>"));
        sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"sys_summary.asp\"><b><font color=\"#C0C0C0\">System Summary</font></b></a></td>"));
        sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"sys_rf.asp\"><b><font color=\"#C0C0C0\">Wireless</font></b></a></td>"));
        sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"sys_bridge.asp\"><b><font color=\"#C0C0C0\">Bridge</font></b></a></td>"));
        sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"sys_security.asp\"><b><font color=\"#C0C0C0\">Security</font></b></a></td>"));
        sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"sys_survey.asp\"><b><font color=\"#C0C0C0\">Site Survey</font></b></a></td>"));
        sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"sys_brdg_table.asp\"><b><font color=\"#C0C0C0\">Bridge Table</font></b></a></td>"));
        sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"sys_admin.asp\"><b><font color=\"#C0C0C0\">Admin</font></b></a></td>"));
        sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"fw_upgrade.asp\"><b><font color=\"#C0C0C0\">Firmware Upgrade</font></b></a></td>"));
        sp += websWrite(wp, T("</tr></table>"));
    }

    return sp;
}

IMPLEMENT_ASP(asp_get_site_survey) {

    int sp = 0;
    int i;
    unsigned char tmpBufSSID[100];
    APICMDBUF_GET_SURVEY_INFO getSurveyInfo;
    API_SURVEY_ENTRY *ssEntry_p;
    DECLARE_0_ASP_ARGS;

    if (ApCmdGetProc(APCMD_GET_SURVEY_INFO, (char*)&getSurveyInfo) == STATUS_FAIL)
    {
        return sp;
    }

    for (i=0; i < getSurveyInfo.maxEntry; i++)
    {
        ssEntry_p = getSurveyInfo.infoAddr + (i * sizeof(API_SURVEY_ENTRY));

        if (ssEntry_p->dirty)
        {
            memset(tmpBufSSID, 0, 33);
            stringToHtmlString(ssEntry_p->SsId, 32, &tmpBufSSID[0], 100);
#if 0
            sp += websWrite(wp, T("<tr><td width=\"5\%\" bgcolor=\"#ffff99\"><input type=\"radio\" name=\"peer\" value=\"%02x%02x%02x%02x%02x%02x\" ></td>\n"),
                            ssEntry_p->BssId[0], ssEntry_p->BssId[1], ssEntry_p->BssId[2], ssEntry_p->BssId[3], ssEntry_p->BssId[4], ssEntry_p->BssId[5]);
#else
            sp += websWrite(wp, T("<tr><td width=\"5\%\" bgcolor=\"#ffff99\"><input type=\"radio\" name=\"peer\" value=\"%s\" ></td>\n"),
                            tmpBufSSID);

#endif
            sp += websWrite(wp, T("<td width=\"20\%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), tmpBufSSID);
            sp += websWrite(wp, T("<td width=\"20\%\" bgcolor=#ffff99><nobr>%02x-%02x-%02x-%02x-%02x-%02x</nobr></td>\n"),
                            ssEntry_p->BssId[0], ssEntry_p->BssId[1], ssEntry_p->BssId[2], ssEntry_p->BssId[3], ssEntry_p->BssId[4], ssEntry_p->BssId[5]);
            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), ssEntry_p->channel);
            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>%s</nobr></td>\n"), ssEntry_p->IBSS?"No":"Yes");
            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), ssEntry_p->G_Support?"G":"B");

            if (ssEntry_p->wpaEnabled)
            {
                sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA</nobr></td>\n"));
            }
            else
            {
                if (ssEntry_p->wepEnabled)
                {
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WEP</nobr></td>\n"));
                }
                else
                {
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>OPEN</nobr></td>\n"));
                }
            }
            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td></tr>\n"), ssEntry_p->RSSI);
        }
    }
    return sp;
}

#endif /* AP_SITE_SURVEY */
