 /*
 *                Copyright 2003, Marvell Semiconductor, Inc.
 * This code contains confidential information of Marvell Semiconductor, Inc.
 * No rights are granted herein under any patent, mask work right or copyright
 * of Marvell or any third party.
 * Marvell reserves the right at its sole discretion to request that this code
 * be immediately returned to Marvell. This code is provided "as is".
 * Marvell makes no warranties, express, implied or otherwise, regarding its
 * accuracy, completeness or performance.
 */
 
 /*!
  * \file    wins_api.c
  * \brief   API interface to get needed configuration parameter.
  *          Such as the device (NetBios) name, and device IP Configuration.
  *
  * $Revision: 1.2 $
  * $Date: 2003/09/23 00:24:44 $
  */
 
#include "wltypes.h"
#include "ap_api.h"

#include <cyg/infra/cyg_type.h>
#include  <network.h>

/***********************************************/
/* Global declaration                          */
/***********************************************/
unsigned long winsIpAddr = 0x0200a8c0;
unsigned char winsName[24];



/*************************************************************************
* Function:
*
* Description:
*
* Input:
*
* Output:
*
**************************************************************************/
static void strupr(unsigned char *pStr)
{
    int i;
    int lenStr = strlen(pStr);

    for (i=0; i < lenStr; i++)
    {
        if ( *(pStr + i) > 0x60 && *(pStr + i) < 0x7b)
        {
            *(pStr + i) = *(pStr + i) - 0x20;

        }
    }

}



/*************************************************************************
* Function:
*
* Description:
*
* Input:
*
* Output:
*
**************************************************************************/
unsigned long winsGetEthIp(void)
{
    APICMDBUF_GET_ETH_IP_CONFIG Cmdbuf;

    Cmdbuf.cmdCode = APCMD_GET_ETH_IP_CONFIG;
    Cmdbuf.seqNum = 1;
    Cmdbuf.cmdBodyLen = 32; /* has to be greater than 32 */
    apctl(&Cmdbuf);


    return /*htonl*/(Cmdbuf.ipAddress);
/*    return winsIpAddr; */
}

/*************************************************************************
* Function:
*
* Description:
*
* Input:
*
* Output:
*
**************************************************************************/
unsigned char *winsGetDevName(void)
{
    APICMDBUF nameCmdbuf;

    if ((nameCmdbuf.cmdBody = malloc(16)) == NULL)
    {
        return NULL;
    }
    nameCmdbuf.cmdCode = APCMD_GET_DEVICE_NAME;
    nameCmdbuf.seqNum = 1;
    nameCmdbuf.cmdBodyLen = 16; 
    apctl(&nameCmdbuf);
    memset(winsName, 0, 24);
    strcpy(winsName, nameCmdbuf.cmdBody);
    strupr(winsName);
    free(nameCmdbuf.cmdBody);

    return &winsName[0];
}

