#ifndef SPIEEPROM_H

#define SPIEEPROM_H

#define _REG(x) (*(volatile unsigned long *) (x))

    // access 32 bits register

#define _REG16(x) (*(volatile unsigned short *) (x))


#define _REG8(x)  (*(volatile unsigned char *)(x))

//#define W2B(addr) (addr << 1)   // word addr converted to byte addr

#define STAT     0x8000C11C



// 25LC040 SPI 8-bit instr's

#define WRSR   0x01            // write status register

#define WRITE  0x02

#define READ   0x03

#define WRDI   0x04            // reset write enable

#define RDSR   0x05            // read status reg

#define WREN   0x06            // set write enable

#define SE_ST25P10A     0xd8   // sector erase

#define SE_SST25VF010   0x52   // sector erase

#define EWRSR  0x50            // enable write status register



// CSU 16-bit SPI commd's

#define SPI_WREN    0x0420

#define SPI_SECTORERASE  0x0481

#define SPI_WRDI    0x0410

#define SPI_RDSR    0x0408

#define SPI_WRSR    0x0404

#define SPI_ADDR3_READ1  0x04c2       // read for 3 byte addr

#define SPI_ADDR3_WRITE1 0x04c1       // write for 3 byte addr

#define SPI_ADDR2_READ1  0x0482       // read for 2 byte addr

#define SPI_ADDR2_WRITE1 0x0481       // write for 2 byte addr



// CSU register address

#define PRER     0x8000C100

#define GCTRL    0x8000C104

#define SPICTRL  0x8000C108

#define SPIDATA  0x8000C124



#define SIGNATURE_SFLASH    0xc5c01688

//#define SIGNATURE_VENDOR    0xc5c01688

#define SFLASH_TYPE_SST25VF010  0x49

#define SFLASH_TYPE_ST25P10A    0x10

extern uint8 spiGetID();
extern void w81_spiInitGetBus(void);
extern void spiSectorErase(int addr);
extern void spiWriteA2D1(int addr, unsigned char data);
extern unsigned char spiReadA2D1(int addr);

#endif
